var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Created by w on 2017/4/18.
 */
var behavior;
(function (behavior) {
    (function (e_Type) {
        e_Type[e_Type["e_node"] = 0] = "e_node";
        e_Type[e_Type["e_actionNode"] = 1] = "e_actionNode";
        e_Type[e_Type["e_conditionNode"] = 2] = "e_conditionNode";
        e_Type[e_Type["e_behaviorNode"] = 3] = "e_behaviorNode";
    })(behavior.e_Type || (behavior.e_Type = {}));
    var e_Type = behavior.e_Type;
    (function (e_State) {
        e_State[e_State["e_Waiting"] = 0] = "e_Waiting";
        e_State[e_State["e_Executing"] = 1] = "e_Executing";
        e_State[e_State["e_Completed"] = 2] = "e_Completed";
    })(behavior.e_State || (behavior.e_State = {}));
    var e_State = behavior.e_State;
    (function (e_condition_Type) {
        e_condition_Type[e_condition_Type["e_dayu"] = 0] = "e_dayu";
        e_condition_Type[e_condition_Type["e_dengyu"] = 1] = "e_dengyu";
        e_condition_Type[e_condition_Type["e_xiaoyu"] = 2] = "e_xiaoyu";
    })(behavior.e_condition_Type || (behavior.e_condition_Type = {}));
    var e_condition_Type = behavior.e_condition_Type;
    //所有节点的父类
    var Node = (function () {
        function Node() {
            this.m_Parent = null; //父节点
            this.m_Children = null; //子对象链表
            this.m_name = "Node"; //类名
            this.m_Type = null; //节点类型
            this.m_State = null; //当前状态
            this.m_Children = new Array();
        }
        Node.prototype.addChild = function (child) {
            child.setParent(this);
            this.m_Children.push(child);
        };
        Node.prototype.setParent = function (parent) {
            this.m_Parent = parent;
        };
        Node.prototype.Enter = function (data) {
            this.m_State = e_State.e_Executing;
        };
        Node.prototype.Exit = function (data) {
            this.m_State = e_State.e_Waiting;
        };
        Node.prototype.child_Complete_Callback = function (child) {
            child.Exit.call(child, null);
        };
        Node.prototype.Execute = function () {
        };
        Node.prototype.getState = function () {
            return this.m_State;
        };
        Node.prototype.shutdown = function () {
        };
        Node.prototype.update = function (t) {
            if (this.m_State == e_State.e_Completed) {
                if (this.m_Parent) {
                    this.m_Parent.child_Complete_Callback(this);
                }
            }
        };
        return Node;
    }());
    behavior.Node = Node;
    //条件节点
    var condition_struct = (function () {
        function condition_struct(f, c, t) {
            this.m_func = null; //这里传入的参数必须是比较型的 function():boolean{ player.x > 100 }
            this.m_condition = null;
            this.m_Target = null;
            this.m_func = f;
            this.m_condition = c;
            this.m_Target = t;
        }
        return condition_struct;
    }());
    behavior.condition_struct = condition_struct;
    var condition_Node = (function (_super) {
        __extends(condition_Node, _super);
        function condition_Node(condition, role) {
            _super.call(this);
            this.m_conditionArray = null;
            this.m_ControlNode = null;
            this.m_ControlRole = null;
            this.m_conditionArray = new Array();
            this.m_Type = e_Type.e_conditionNode;
            this.m_ControlRole = role;
            this.m_ControlNode = null;
        }
        condition_Node.create = function (condition, role) {
            return new condition_Node(condition, role);
        };
        // 创建时的当前条件为传入条件，则执行对应节点
        condition_Node.prototype.register = function (data) {
            data.m_condition.setParent(this);
            this.m_conditionArray.push(data);
        };
        condition_Node.prototype.SelectConditionNode = function () {
            for (var k = 0; k < this.m_conditionArray.length; k++) {
                var data = this.m_conditionArray[k];
                //如果当前条件返回结果为true 选择该条件的节点做为执行节点 需要考虑优先级
                if (data.m_func.call(data.m_Target)) {
                    this.m_ControlNode = data.m_condition;
                    this.m_ControlNode.Enter(this.m_ControlRole);
                    return true;
                }
            }
            return false;
        };
        condition_Node.prototype.child_Complete_Callback = function (child) {
            child.Exit(null);
            this.m_ControlNode = null;
            if (this.SelectConditionNode() == false) {
            }
        };
        condition_Node.prototype.update = function (t) {
            if (this.m_ControlNode != null) {
                this.m_ControlNode.update(t);
                //如果当前节点条件已执行完毕 重新选择符合条件的节点
                if (this.m_ControlNode.m_State == e_State.e_Completed) {
                    this.m_ControlNode = null;
                }
            }
            else {
                if (this.SelectConditionNode() == false) {
                }
            }
        };
        return condition_Node;
    }(Node));
    behavior.condition_Node = condition_Node;
    var Behavior_Tree = (function () {
        function Behavior_Tree() {
            this.m_Children = null;
            this.m_ControlNode = null; //当前控制的节点
            this.m_ControlRole = null; //当前控制的对象
            this.m_Children = new Array();
        }
        Behavior_Tree.create = function () {
            return new Behavior_Tree();
        };
        Behavior_Tree.prototype.getChildByname = function (name) {
            for (var k = 0; k < this.m_Children.length; k++) {
                if (this.m_Children[k].m_name === name) {
                    return this.m_Children[k];
                }
            }
            return null;
        };
        Behavior_Tree.prototype.addChild = function (node) {
            //node.setParent( this )
            this.m_Children.push(node);
        };
        Behavior_Tree.prototype.update = function (t) {
            if (this.m_ControlNode == null) {
            }
            else {
                this.m_ControlNode.update(t);
            }
        };
        return Behavior_Tree;
    }());
    behavior.Behavior_Tree = Behavior_Tree;
})(behavior || (behavior = {}));
//# sourceMappingURL=behavior.js.map