/**
 * Created by cy1234 on 2016/7/14.
 */
//   与c++ 交互的类
module game {
    export let g_httpType = {
        type_saveScore: "saveScore",
        type_getwujingRank: "getwujingRank",
        type_getxianshiRank: "xianshiRank",
        type_getxianshiRankList: "xianshiRankList",
        type_getwujingRankList: "wujingRankList",
        type_setRank: "setRank",
        type_getScoreList: "GetScoreList",
        type_getGameData: "getGameData",
        type_saveGameData: "saveGameData",
        type_userAward: "userAward",
        type_serverTime:"GetServerTime",
        type_getUserName:"GetUserNickNames",
        type_setUserName:"SetUserNickName",
        type_getwujingScore:"getwujingScore",
        type_getxianshiScore:"getxianshiScore",
        type_CDKEY:"type_CDKEY"
    };
    export class HttpBaseNative {
        m_HttpBaseJs: any = null;
        m_is_send: any = false;

        static create = function () {
            return new HttpBaseNative();
        };

        constructor() {
            this.init();
        }

        init() {
            if (cc.sys.isNative) {

                this.m_HttpBaseJs = new cc.HttpBaseJs();
                this.m_HttpBaseJs.onHttpRequestCompleted = this.onHttpRequestCompleted.bind(this);
                this.m_HttpBaseJs.onError = this.onError;
            }
            else {
                this.m_HttpBaseJs = cc.loader.getXMLHttpRequest();
            }
        }

        //isPost : 1 POST 模式 0 ：GET 模式
        httpSendMsg(url, isPost: number = 0, isshengjianserver: boolean = true) {
            console.log(url);
            if (cc.sys.isNative) {
                if (this.m_HttpBaseJs) {
                    this.m_HttpBaseJs.onSendMsg(url, isPost, isshengjianserver);
                }
                else {
                    this.onError();
                }
            }
            else {
                this.m_HttpBaseJs.open("GET", url, true);
                this.m_HttpBaseJs.setRequestHeader("Access-Control-Allow-Origin", "*");
                this.m_HttpBaseJs.onreadystatechange = this.httpCallBack.bind(this);
                this.m_HttpBaseJs.send(null);
            }
        }

        httpCallBack() {
            if (this.m_HttpBaseJs.readyState != 4) {
                return;
            }
            if (this.m_HttpBaseJs.readyState == 4 && (this.m_HttpBaseJs.status >= 200 && this.m_HttpBaseJs.status <= 207)) {
                this.onHttpRequestCompleted(this.m_HttpBaseJs.responseText, this.m_HttpBaseJs.responseText.Description);
            }
            else {
                this.onError();
            }
        }

        onError() {
            this.m_is_send = false;
            ui_MessageBox2.ShowOrHide(true,"连接服务器失败!",function () {
                cc.director.end()
            });
        }

        onHttpRequestCompleted(data, Description) {
        }
    }

    export class httpBase extends HttpBaseNative {
        m_sendUrl: any = null;
        m_downloaderror: any = false;
        m_type: any = null;

        constructor() {
            super();
        }

        addWorld(key, val) {
            let data = "";
            data = "&" + key + "=" + val;
            this.m_sendUrl += data;
        }

        shutdown() {
        }

        onSendMsg(data, data1) {
        }

        onHttpRequestCompleted(data, Description) {
            this.m_is_send = false;
        }

        onError() {
            super.onError();
        }

        isError() {
            return this.m_downloaderror;
        }

        loop(t) {
        }

        generateSign(isBossID, isAccount, isGameID, ResultObj, DataObj, CountObj, VIPObj, OpTypeObj,
                     GameDataObj, ScoreObj, NumberObj, PhoneObj, TypeObj, ValueObj, ExtendObj,NickNameObj,NumObj,CDKeyObj,isUserID) {
            let game_PrivateKey = httpMgr.getMe().g_game_PrivateKey;
            let Source = "";
            let BossID = iapMgr.getMe().getplatformId();
            let Account = iapMgr.getMe().getaccount();
            let GameID = iapMgr.getMe().getGameId();
            let UserID = iapMgr.getMe().getaccount();

            if (isAccount) {
                Source += Account;
            }
            if (isBossID) {
                Source += BossID;
            }

            if(CDKeyObj != null){
                Source += CDKeyObj;
            }
            if (CountObj != null) {
                Source += CountObj;
            }
            if (DataObj != null) {
                Source += DataObj;
            }

            if (ExtendObj != null)
                Source += ExtendObj;

            if (GameDataObj != null) {
                Source += js_GameLogicMgr.getMe().encode(GameDataObj);
            }
            if (isGameID) {
                Source += GameID;
            }
            if (NumberObj != null)
                Source += NumberObj;
            if (OpTypeObj != null) {
                Source += OpTypeObj;
            }
            if (PhoneObj != null)
                Source += PhoneObj;
            if (ResultObj != null) {
                Source += ResultObj;
            }

            if(NumObj != null){
                Source += NumObj;
            }
            if(NickNameObj != null){
                Source += encodeEX(NickNameObj);
            }
            if (ScoreObj != null)
                Source += ScoreObj;
            if (TypeObj != null)
                Source += TypeObj;
            if( isUserID ){
                Source += UserID;
            }
            if (VIPObj != null) {
                Source += VIPObj;
            }
            if (ValueObj != null)
                Source += ValueObj;



            let MySign = Source + game_PrivateKey;
            console.log("..key....."+ MySign)
            return game.hex_md5(MySign);
        }

        onSendMsgEx(url, isBossID, isAccount, isGameID, ResultObj?, DataObj?, CountObj?, VIPObj?, OpTypeObj?,
                    GameDataObj?, ScoreObj?, NumberObj?, PhoneObj?, TypeObj?, ValueObj?, ExtendObj? ,NickNameObj?,NumObj?,CDKeyObj?,isUserID?) {
            url = httpMgr.getMe().g_url_server_one + url + "?";
            let Result = "";
            let Data = "";
            let Count = "";
            let VIP = "";
            let OpType = "";
            let GameData = "";
            let BossID = "&BossID=" + iapMgr.getMe().getplatformId();
            let Account = "&Account=" + iapMgr.getMe().getaccount();//
            let UserID = "&UserID=" + iapMgr.getMe().getaccount();//Account

            let GameID = "&GameID=" + iapMgr.getMe().getGameId();
            if (DataObj != null) {
                Data = "&Data=" + DataObj;
            }
            if (OpTypeObj != null) {
                OpType = "&OpType=" + OpTypeObj;
            }
            if (CountObj != null) {
                Count = "&Count=" + CountObj;
            }
            if (ResultObj != null) {
                Result = "&Result=" + ResultObj;
            }
            if (VIPObj != null) {
                VIP = "&VIP=" + VIPObj;
            }
            let sign = "&sign=" + this.generateSign(isBossID, isAccount, isGameID, ResultObj, DataObj, CountObj, VIPObj,
                    OpTypeObj, GameDataObj, ScoreObj, NumberObj, PhoneObj, TypeObj, ValueObj, ExtendObj,NickNameObj,NumObj,CDKeyObj,isUserID);
            if (GameDataObj != null) {
                GameData = "&GameData=" + js_GameLogicMgr.getMe().encode(GameDataObj).replace(/%/g,"");;
            }
            if (NumberObj != null)
                url += "&Num=" + NumberObj;

            if (isAccount) {
                url += Account;
            }

            if (isBossID) {
                url += BossID;
            }

            // if(UserID){
            //     url += ("&UserID=" + UserID);
            // }
            if (DataObj != null) {
                url += Data;
            }
            if( CDKeyObj != null){
                url += "&CDKey=" + CDKeyObj;
            }
            if (CountObj != null) {
                url += Count;
            }
            if (isGameID) {
                url += GameID;
            }
            if (OpTypeObj != null) {
                url += OpType;
            }
            if (GameDataObj != null) {
                url += GameData;
            }
            if (ResultObj != null) {
                url += Result;
            }
            if (VIPObj != null) {
                url += VIP;
            }

            if (PhoneObj != null) {
                url += "&Phone=" + PhoneObj;
            }
            if(NumObj != null){
                url += "&Num=" + NumObj;
            }
            if(NickNameObj != null){
                url += "&NickName=" + encodeEX(NickNameObj);
            }
            if (ScoreObj != null){
                url += "&Score=" + ScoreObj;
            }

            if (TypeObj != null) {
                url += "&Type=" + TypeObj;
            }
            if( isUserID ){
                url += UserID
            }
            if (ValueObj != null) {
                url += "&Value=" + ValueObj;
            }
            if (ExtendObj != null) {
                url += "&Extend=" + ExtendObj;
            }

            url += sign;
            url = url.replace("?&", "?");
            return url;
        }

    }
}
