/**
 * Created by xieli on 2017/4/7.
 */
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 一、地图格子划分检测
//
// 最简单的一种检测，就是把地图（或者称为场景，总之是指碰撞发生的范围）划成一个个格子，类似仙剑奇侠传这样。假设地图有800*600px，20*20个像素为一格。
// 那么可以划为40*30个格子。地图中参与检测的对象都存储着自身所在的格子坐标，判断碰撞就显而易见了，例如可以认为两个物体在相邻格判为碰撞，或者两个物体在同一格。
// 采用这种方式有个要求，就是地图中所有可能参与碰撞的物体都要是20*20像素左右大小或者是其整数倍，例如房子占了3*3个格子，诸如此类。如果不遵守这个规则，有的物体只占了格子的一半，
// 那么在玩家眼里这种检测就显得非常的粗糙。这种检测就像是把地图的像素点放大几十倍一样，
// 与逐像素检测相比，效率提高了几十倍甚至上百倍。这种方式可运用于对检测要求不严格的游戏，例如踩地雷的RPG、推箱子之类的智力游戏。
var game;
(function (game) {
    // let g_geziweiyiid = 0;
    var geziObj = (function (_super) {
        __extends(geziObj, _super);
        function geziObj(texture, pos, type, parent) {
            _super.call(this);
            this.m_parentId = -1;
            this.m_sprite = null;
            this.m_score = 0;
            this.m_parentNode = null;
            this.m_parentNode = parent;
            var foodConfig = game.getFoodConfigByType(type);
            if (foodConfig) {
                this.m_score = foodConfig.score;
                this.m_sprite = new cc.Sprite(texture);
                this.m_sprite.setScale(foodConfig.scale);
                this.m_sprite.setPosition(pos);
            }
            var fadeIn = cc.fadeIn(game.g_energy_config.FadeIn_Time);
            this.m_sprite.opacity = 0;
            this.m_sprite.runAction(fadeIn);
            this.m_parentNode.addChild(this.m_sprite);
        }
        geziObj.prototype.shutdown = function () {
            this.m_parentNode.removeChild(this.m_sprite);
            this.m_sprite = null;
        };
        geziObj.prototype.getScore = function () {
            return this.m_score;
        };
        geziObj.prototype.getPos = function () {
            return this.m_sprite.getPosition();
        };
        return geziObj;
    }(game.baseObj));
    game.geziObj = geziObj;
    var RoleQiequ = (function () {
        function RoleQiequ(p, parent, targetNode) {
            this.m_spr = null;
            this.m_parent = null;
            this.m_targeNode = null;
            this.m_isComplete = false;
            var foodConfig = game.getBigFood_Rand();
            this.m_spr = cc.Sprite.create(foodConfig.img);
            this.m_spr.setScale(foodConfig.scale);
            var fadeIn = cc.fadeIn(game.g_energy_config.FadeIn_Time / 2);
            this.m_spr.opacity = 0;
            this.m_spr.setPosition(p);
            this.m_spr.runAction(fadeIn);
            this.m_parent = parent;
            this.m_parent.addChild(this.m_spr);
            this.m_targeNode = targetNode;
            this.m_isComplete = false;
        }
        RoleQiequ.prototype.shutdown = function () {
            this.m_parent.removeChild(this.m_spr);
            this.m_spr = null;
        };
        RoleQiequ.prototype.update = function (t, speed) {
            if (this.m_targeNode == null) {
                this.m_isComplete = true;
                return;
            }
            var m_p = this.m_spr.getPosition();
            var o_p = this.m_targeNode.getPos();
            var dir = cc.pNormalize(cc.pSub(o_p, m_p));
            this.m_spr.setPosition(cc.pAdd(m_p, cc.pMult(dir, (speed + Math.floor(t * 100)) * 2)));
            if (cc.pDistance(m_p, o_p) <= 10) {
                this.m_isComplete = true;
            }
        };
        return RoleQiequ;
    }());
    game.RoleQiequ = RoleQiequ;
    var SpriteBatchNodeEx = (function () {
        function SpriteBatchNodeEx(n, type, parent) {
            this.m_node = null;
            this.m_type = null;
            this.m_parent = null;
            this.m_node = cc.SpriteBatchNode.create(n);
            this.m_type = type;
            this.m_parent = parent;
            this.m_parent.addChild(this.m_node, -10000);
        }
        SpriteBatchNodeEx.prototype.shutDown = function () {
            this.m_node.removeAllChildren();
            this.m_parent.removeChild(this.m_node);
            this.m_node = null;
        };
        SpriteBatchNodeEx.prototype.getNode = function () {
            return this.m_node;
        };
        SpriteBatchNodeEx.prototype.getTexture = function () {
            return this.m_node.getTexture();
        };
        return SpriteBatchNodeEx;
    }());
    game.SpriteBatchNodeEx = SpriteBatchNodeEx;
    var mapGezi = (function () {
        function mapGezi() {
            this.m_mapList = null;
            this.m_map_width = null;
            this.m_map_height = null;
            this.m_unit_map_size = 300;
            this.m_energyNode = null; //SpriteBatchNode
            this.m_unit_obj_size = 20;
            this.m_updateTime = 0;
            this.m_curFoodnum = 0;
            this.m_parent = null;
        }
        mapGezi.getMe = function () {
            if (mapGezi.g_mapGezi == null) {
                mapGezi.g_mapGezi = new mapGezi();
                return mapGezi.g_mapGezi;
            }
            else {
                return mapGezi.g_mapGezi;
            }
        };
        ;
        mapGezi.prototype.init = function (parent, w, h, gezi_w, gezi_h) {
            if (w === void 0) { w = 3000; }
            if (h === void 0) { h = 3000; }
            if (gezi_w === void 0) { gezi_w = this.m_unit_map_size; }
            if (gezi_h === void 0) { gezi_h = this.m_unit_map_size; }
            this.m_mapList = new game.Map();
            this.m_unit_obj_size = game.g_energy_config.unitSize;
            this.m_energyNode = new Array(); //g_energy_config.foodimg
            for (var k = 0; k < game.g_energy_config.foodimg.length; k++) {
                var newNode = new SpriteBatchNodeEx(game.g_energy_config.foodimg[k].img, game.g_energy_config.foodimg[k].type, parent);
                newNode.m_node.setPosition(cc.p(0, 0));
                this.m_energyNode[k] = newNode;
            }
            this.m_parent = parent;
            this.m_map_width = w;
            this.m_map_height = h;
            this.m_updateTime = game.g_energy_config.updateTime;
            var map_ID = 0;
            for (var y = 1; y < h + 1; y += gezi_h) {
                for (var x = 1; x < w + 1; x += gezi_w) {
                    var map = new game.Map();
                    map.setId(++map_ID);
                    this.m_mapList.set(map_ID, map);
                }
            }
            for (var j = 0; j < game.g_energy_config.food_number; j++) {
                this.addGeziObj(this.getRandPos());
            }
        };
        mapGezi.prototype.getRandPos = function () {
            var pos = new cc.Vec2(Math.random() * (this.m_map_width - (game.g_map_config.border_width + 100) * 2) + (game.g_map_config.border_width + 100), Math.random() * (this.m_map_height - (game.g_map_config.border_height + 100) * 2) + (game.g_map_config.border_height + 100));
            pos = this.posUnit(pos);
            return pos;
        };
        mapGezi.prototype.shutDown = function () {
            this.m_mapList.forEach(function (v_, k_, map_) {
                v_.forEach(function (v, k, map) {
                    v.shutdown();
                }, this);
                v_.clear();
            }, this);
            this.m_mapList.clear();
            if (this.m_energyNode) {
                if (this.m_energyNode.length != 0) {
                    for (var k = 0; k < this.m_energyNode.length; k++) {
                        this.m_energyNode[k].shutDown;
                    }
                }
                this.m_energyNode.length = 0;
                this.m_energyNode = null;
            }
            this.m_curFoodnum = 0;
        };
        mapGezi.prototype.getEnergyParent = function (type) {
            for (var k = 0; k < this.m_energyNode.length; k++) {
                if (this.m_energyNode[k].m_type == type) {
                    return this.m_energyNode[k];
                }
            }
        };
        mapGezi.prototype.addGeziObj = function (pos, type, img) {
            if (type === void 0) { type = null; }
            if (img === void 0) { img = null; }
            pos = this.posUnit(pos);
            if (pos.x > game.g_map_config.map_width - game.g_map_config.border_width - 50
                || pos.x < game.g_map_config.border_width + 50
                || pos.y > game.g_map_config.map_height - game.g_map_config.border_height - 50
                || pos.y < game.g_map_config.border_height + 50) {
                //console.log("超过屏幕边界，")
                return;
            }
            if (this.objInList(pos)) {
                //console.log("添加失败，该坐标已存在对象")
                return;
            }
            if (type == null) {
                if (Math.random() * 100 < game.g_energy_config.bigFood_Prog) {
                    type = game.getBigFood_Rand().type;
                }
                else {
                    type = game.getSmallFood_Rand().type;
                }
            }
            var EnergyParent = this.getEnergyParent(type);
            var obj = new geziObj(EnergyParent.getTexture(), pos, type, EnergyParent.getNode());
            var objList = this.getObjListByPos(pos);
            if (objList == null) {
                return null;
            }
            var geziKey = this.getTagByPos(pos);
            obj.m_id = geziKey;
            obj.m_parentId = objList.getId(); //this.m_mapList.getKeyByData( objList )
            objList.set(geziKey, obj);
            ++this.m_curFoodnum;
            return obj;
        };
        mapGezi.prototype.deleteByObj = function (data) {
            var parentMap = this.m_mapList.get(data.m_parentId);
            if (parentMap == null) {
                return false;
            }
            data.shutdown();
            parentMap.delete(data.m_id);
            --this.m_curFoodnum;
            return true;
        };
        mapGezi.prototype.posUnit = function (pos) {
            pos.x = Math.ceil(pos.x / this.m_unit_obj_size) * this.m_unit_obj_size;
            pos.y = Math.ceil(pos.y / this.m_unit_obj_size) * this.m_unit_obj_size;
            return pos;
        };
        mapGezi.prototype.loop = function (t) {
            this.m_updateTime -= t;
            if (this.m_updateTime <= 0) {
                if (this.m_curFoodnum < game.g_energy_config.food_number) {
                    for (var j = 0; j < 5; j++) {
                        this.addGeziObj(this.getRandPos());
                    }
                }
                this.m_updateTime = game.g_energy_config.updateTime;
            }
        };
        mapGezi.prototype.colide = function (obj) {
            if (obj.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return;
            }
            var pos = obj.getHeadPos();
            for (var j = -2; j <= 2; j++) {
                for (var k = -2; k <= 2; k++) {
                    var p = new cc.Vec2(pos.x + j * this.m_unit_obj_size, pos.y + k * this.m_unit_obj_size);
                    p = this.posUnit(p);
                    var datalist = this.getObjListByPos(p);
                    if (!datalist) {
                        //不在当前所有MAP列表中的情况
                        return;
                    }
                    var tag = this.getTagByPos(p);
                    var data = datalist.get(tag);
                    if (data) {
                        var headSize = obj.m_head.getradius();
                        var foodSize = data.m_sprite.getBoundingBox().width / 2;
                        var len = cc.pDistance(obj.getHeadPos(), data.getPos());
                        if (len < (headSize + foodSize + game.g_Snake_Config.eatFood_len)) {
                            //这里写吃食物的动作逻辑
                            obj.addFood(data);
                            if (obj.m_Type == game.g_ObjType.monster) {
                                obj.changeState_Ex(game.g_AiType.g_AiType_findFood);
                            }
                        }
                    }
                }
            }
        };
        //MAP对象的键值
        mapGezi.prototype.getTagByPos = function (pos) {
            pos = this.posUnit(pos);
            var x = Math.ceil(pos.x / this.m_unit_obj_size);
            var y = Math.floor(pos.y / this.m_unit_obj_size);
            return y * this.m_unit_obj_size + x;
        };
        //第一层MAP的键值
        mapGezi.prototype.getKeyByPos = function (pos) {
            var x = Math.ceil(pos.x / this.m_unit_map_size);
            var y = Math.floor(pos.y / this.m_unit_map_size);
            return y * (this.m_map_width / this.m_unit_map_size) + x;
        };
        mapGezi.prototype.objInList = function (pos) {
            var key = this.getKeyByPos(pos);
            var map = this.m_mapList.get(key);
            if (map == null) {
                return false;
            }
            else {
                var tag = this.getTagByPos(pos);
                if (map.get(tag)) {
                    return true;
                }
            }
            return false;
        };
        mapGezi.prototype.getObjByPos = function (pos) {
            var map = this.getObjListByPos(pos);
            if (map == null) {
                return null;
            }
            var tag = this.getTagByPos(pos);
            return map.get(tag);
        };
        mapGezi.prototype.getObjListByPos = function (pos) {
            var key = this.getKeyByPos(pos);
            return this.m_mapList.get(key);
        };
        mapGezi.g_mapGezi = null;
        return mapGezi;
    }());
    game.mapGezi = mapGezi;
})(game || (game = {}));
//# sourceMappingURL=mapGezi.js.map