/**
 * Created by xieli on 2017/4/7.
 */

// 一、地图格子划分检测
//
// 最简单的一种检测，就是把地图（或者称为场景，总之是指碰撞发生的范围）划成一个个格子，类似仙剑奇侠传这样。假设地图有800*600px，20*20个像素为一格。
// 那么可以划为40*30个格子。地图中参与检测的对象都存储着自身所在的格子坐标，判断碰撞就显而易见了，例如可以认为两个物体在相邻格判为碰撞，或者两个物体在同一格。
// 采用这种方式有个要求，就是地图中所有可能参与碰撞的物体都要是20*20像素左右大小或者是其整数倍，例如房子占了3*3个格子，诸如此类。如果不遵守这个规则，有的物体只占了格子的一半，
// 那么在玩家眼里这种检测就显得非常的粗糙。这种检测就像是把地图的像素点放大几十倍一样，
// 与逐像素检测相比，效率提高了几十倍甚至上百倍。这种方式可运用于对检测要求不严格的游戏，例如踩地雷的RPG、推箱子之类的智力游戏。
module game {

   // let g_geziweiyiid = 0;
    export class geziObj  extends baseObj{
        m_foogType: e_food_Type;
        m_parentId:number = - 1
        m_id: number; //唯一id
        m_sprite:cc.Sprite = null
        m_score:number = 0
        m_parentNode = null
        constructor(texture:any ,pos:cc.Vec2 ,type: e_food_Type ,parent:cc.Node){
            super()
            this.m_parentNode = parent
            let foodConfig = getFoodConfigByType(type)
            if(foodConfig){
                this.m_score = foodConfig.score
                this.m_sprite = new cc.Sprite( texture )
                this.m_sprite.setScale( foodConfig.scale )
                this.m_sprite.setPosition(pos)
            }
            let fadeIn = cc.fadeIn( g_energy_config.FadeIn_Time );
            this.m_sprite.opacity = 0
            this.m_sprite.runAction(fadeIn)
            this.m_parentNode.addChild(this.m_sprite)
        }
        shutdown()
        {
            this.m_parentNode.removeChild( this.m_sprite )
            this.m_sprite = null
        }
        getScore(){
            return this.m_score
        }
        getPos():cc.Vec2{
            return this.m_sprite.getPosition()
        }
    }
    export class RoleQiequ{
        m_spr:cc.Sprite = null
        m_parent:cc.Node = null
        m_targeNode:node = null
        m_isComplete:boolean = false
        constructor( p:cc.Vec2 , parent:cc.Node ,targetNode:node ){
            let foodConfig = getBigFood_Rand()
            this.m_spr = cc.Sprite.create(foodConfig.img)
            this.m_spr.setScale(foodConfig.scale)
            let fadeIn = cc.fadeIn( g_energy_config.FadeIn_Time / 2 );
            this.m_spr.opacity = 0
            this.m_spr.setPosition(p)
            this.m_spr.runAction(fadeIn)
            this.m_parent = parent
            this.m_parent.addChild(this.m_spr)
            this.m_targeNode = targetNode
            this.m_isComplete = false
        }
        shutdown(){
            this.m_parent.removeChild( this.m_spr )
            this.m_spr = null
        }
        update( t ,speed ){
            if( this.m_targeNode == null ){
                this.m_isComplete = true
                return
            }
            let m_p = this.m_spr.getPosition()
            let o_p = this.m_targeNode.getPos()

            let dir = cc.pNormalize(cc.pSub(o_p , m_p))
            this.m_spr.setPosition( cc.pAdd(m_p,cc.pMult( dir ,(speed + Math.floor(t * 100)) * 2 )) )
            if(cc.pDistance( m_p , o_p) <= 10 ){
                this.m_isComplete = true
            }
        }
    }
    export class SpriteBatchNodeEx{
        m_node:cc.SpriteBatchNode = null
        m_type:e_food_Type = null
        m_parent:cc.Node = null
        constructor(n:string,type:e_food_Type,parent){
            this.m_node = cc.SpriteBatchNode.create(n)
            this.m_type = type
            this.m_parent = parent
            this.m_parent.addChild(this.m_node , - 10000)
        }
        shutDown(){
            this.m_node.removeAllChildren()
            this.m_parent.removeChild(this.m_node)
            this.m_node = null
        }
        getNode(){
            return this.m_node
        }
        getTexture(){
            return this.m_node.getTexture()
        }
    }
    export class mapGezi {
        static g_mapGezi: mapGezi = null;
        static getMe(): mapGezi {
            if (mapGezi.g_mapGezi == null) {
                mapGezi.g_mapGezi = new mapGezi();
                return mapGezi.g_mapGezi;
            }
            else {
                return mapGezi.g_mapGezi;
            }
        };
        m_mapList:Map<number,Map<number,geziObj>> = null
        m_map_width:number = null
        m_map_height:number = null
        m_unit_map_size:number = 300
        m_energyNode:Array<SpriteBatchNodeEx> = null //SpriteBatchNode
        m_unit_obj_size:number = 20
        m_updateTime:number = 0
        m_curFoodnum:number = 0
        m_parent:xjNode = null
        init( parent:xjNode, w: number = 3000, h: number = 3000, gezi_w: number = this.m_unit_map_size, gezi_h: number= this.m_unit_map_size ) {

            this.m_mapList = new Map<number,Map<number,geziObj>>()
            this.m_unit_obj_size = g_energy_config.unitSize
            this.m_energyNode = new Array<SpriteBatchNodeEx>() //g_energy_config.foodimg
            for(let k = 0; k < g_energy_config.foodimg.length; k++){
                let newNode = new SpriteBatchNodeEx(g_energy_config.foodimg[k].img,g_energy_config.foodimg[k].type,parent)
                newNode.m_node.setPosition(cc.p(0,0))
                this.m_energyNode[k] = newNode
            }
            this.m_parent = parent

            this.m_map_width = w
            this.m_map_height = h
            this.m_updateTime = g_energy_config.updateTime
            let map_ID:number = 0
            for( let y = 1; y < h + 1; y += gezi_h  ){
                for( let x = 1; x < w + 1; x += gezi_w  ){
                    let map:Map<number,geziObj> = new Map<number,geziObj>()
                    map.setId( ++map_ID )
                    this.m_mapList.set( map_ID , map )
                }
            }
            for(let j = 0; j < g_energy_config.food_number; j++){
                this.addGeziObj(this.getRandPos())
            }
        }
        getRandPos(){
            let pos = new cc.Vec2( Math.random() *( this.m_map_width - ( g_map_config.border_width + 100 ) * 2 ) + ( g_map_config.border_width + 100 ),
                Math.random() * ( this.m_map_height - ( g_map_config.border_height + 100 ) * 2) + ( g_map_config.border_height + 100 ) )
            pos = this.posUnit(pos)
            return pos
        }
        shutDown(){

            this.m_mapList.forEach(function (v_,k_,map_) {
                v_.forEach(function (v,k,map) {
                    v.shutdown()
                },this)
                v_.clear()
            },this)
            this.m_mapList.clear()

            if(this.m_energyNode){
                if( this.m_energyNode.length!=0){
                    for(let k = 0; k < this.m_energyNode.length; k++){
                        this.m_energyNode[k].shutDown
                    }
                }
                this.m_energyNode.length =  0
                this.m_energyNode = null
            }

            this.m_curFoodnum = 0
        }
        getEnergyParent( type ):SpriteBatchNodeEx{
            for(let k = 0; k < this.m_energyNode.length; k++){
                if(this.m_energyNode[k].m_type == type){
                    return this.m_energyNode[k]
                }
            }
        }
        addGeziObj( pos: cc.Vec2 , type:e_food_Type = null ,img:string = null ) {
            pos = this.posUnit(pos)
            if( pos.x > g_map_config.map_width - g_map_config.border_width  - 50
            || pos.x < g_map_config.border_width + 50
            || pos.y > g_map_config.map_height - g_map_config.border_height - 50
            || pos.y < g_map_config.border_height + 50 ){
                //console.log("超过屏幕边界，")
                return
            }
            if(this.objInList(pos)){
                //console.log("添加失败，该坐标已存在对象")
                return
            }
            if(type == null){
                if(Math.random() * 100 < g_energy_config.bigFood_Prog){
                    type = getBigFood_Rand().type
                }else{
                    type = getSmallFood_Rand().type
                }
            }
            let EnergyParent:SpriteBatchNodeEx = this.getEnergyParent(type)
            let obj:geziObj = new geziObj( EnergyParent.getTexture(),pos , type , EnergyParent.getNode())
            let objList:Map<number,geziObj> = this.getObjListByPos( pos )
            if( objList == null){
                return null
            }

            let geziKey = this.getTagByPos( pos )
            obj.m_id = geziKey
            obj.m_parentId = objList.getId()//this.m_mapList.getKeyByData( objList )
            objList.set(geziKey,obj)
            ++this.m_curFoodnum
            return obj
        }
        deleteByObj( data : geziObj ){
            let parentMap:Map<number,geziObj> = this.m_mapList.get( data.m_parentId )
            if( parentMap == null){
                return false
            }
            data.shutdown()
            parentMap.delete(data.m_id)
            --this.m_curFoodnum
            return true
        }
        posUnit( pos:cc.Vec2 ):cc.Vec2{
            pos.x = Math.ceil( pos.x / this.m_unit_obj_size ) * this.m_unit_obj_size
            pos.y = Math.ceil( pos.y / this.m_unit_obj_size ) * this.m_unit_obj_size
            return pos
        }
        loop(t){
            this.m_updateTime -= t
            if(this.m_updateTime<= 0){
                if(this.m_curFoodnum < g_energy_config.food_number){
                    for(let j = 0; j < 5;j++){
                        this.addGeziObj(this.getRandPos())
                    }
                }
                this.m_updateTime = g_energy_config.updateTime
            }
        }
        colide(obj:baseRole){
            if(obj.getCurStateType() == g_AiType.g_AiType_dead ){
                return
            }
            let pos = obj.getHeadPos()
            for(let j = - 2 ; j <= 2; j++){
                for(let k = - 2; k <= 2 ; k++){
                    let p = new cc.Vec2(pos.x + j * this.m_unit_obj_size , pos.y + k * this.m_unit_obj_size )
                    p = this.posUnit(p)
                    let datalist = this.getObjListByPos(p)
                    if(! datalist){
                        //不在当前所有MAP列表中的情况
                        return
                    }
                    let tag = this.getTagByPos(p)
                    let data:geziObj = datalist.get(tag)
                    if(data) {
                        let headSize = obj.m_head.getradius()
                        let foodSize = data.m_sprite.getBoundingBox().width / 2
                        let len = cc.pDistance(obj.getHeadPos(),data.getPos())
                        if( len < ( headSize + foodSize +  g_Snake_Config.eatFood_len )){
                            //这里写吃食物的动作逻辑
                            obj.addFood( data )
                            if(obj.m_Type == g_ObjType.monster){
                                obj.changeState_Ex(g_AiType.g_AiType_findFood)
                            }
                        }
                    }
                }
            }
        }
        //MAP对象的键值
        getTagByPos( pos:cc.Vec2 ):number{
            pos = this.posUnit(pos)
            let x = Math.ceil( pos.x / this.m_unit_obj_size )
            let y = Math.floor( pos.y / this.m_unit_obj_size )
            return y * this.m_unit_obj_size + x
        }

        //第一层MAP的键值
        getKeyByPos(pos:cc.Vec2):number{
            let x = Math.ceil( pos.x / this.m_unit_map_size )
            let y = Math.floor( pos.y / this.m_unit_map_size )
            return y * ( this.m_map_width / this.m_unit_map_size ) + x
        }

        objInList( pos :cc.Vec2 ):boolean{
            let key = this.getKeyByPos(pos)
            let map = this.m_mapList.get(key)
            if(map == null){
                return false
            }else{
                let tag = this.getTagByPos(pos)
                if(map.get(tag)){
                    return true
                }
            }
            return false
        }
        getObjByPos(pos:cc.Vec2):geziObj{
            let map:Map<number,geziObj> = this.getObjListByPos(pos)
            if(map == null){
                return null
            }
            let tag = this.getTagByPos(pos)
            return map.get(tag)
        }
        getObjListByPos(pos: cc.Vec2): Map<number,geziObj> {
            let key = this.getKeyByPos(pos)
            return this.m_mapList.get(key)
        }
    }
}