"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    (function (e_skillType) {
        e_skillType[e_skillType["e_jiasu"] = 0] = "e_jiasu";
        e_skillType[e_skillType["e_shengzhang"] = 1] = "e_shengzhang";
        e_skillType[e_skillType["e_touqie"] = 2] = "e_touqie";
        e_skillType[e_skillType["e_dilei"] = 3] = "e_dilei";
        e_skillType[e_skillType["e_pengzhang"] = 4] = "e_pengzhang";
        e_skillType[e_skillType["e_yinshen"] = 5] = "e_yinshen";
        e_skillType[e_skillType["e_wudi"] = 6] = "e_wudi";
    })(game.e_skillType || (game.e_skillType = {}));
    var e_skillType = game.e_skillType;
    var SkillManager = (function () {
        function SkillManager() {
        }
        SkillManager.getMe = function () {
            if (!SkillManager.g_instance) {
                SkillManager.g_instance = new SkillManager();
            }
            return SkillManager.g_instance;
        };
        SkillManager.prototype.getSkillTypeByTypeName = function (name) {
            switch (name) {
                case "jiasu": return e_skillType.e_jiasu;
                case "shengzhang": return e_skillType.e_shengzhang;
                case "qiequ": return e_skillType.e_touqie;
                case "dilei": return e_skillType.e_dilei;
                case "pengzhang": return e_skillType.e_pengzhang;
                case "yinshen": return e_skillType.e_yinshen;
                case "wudi": return e_skillType.e_wudi;
                default: return null;
            }
        };
        SkillManager.prototype.createAction = function (count, fileName) {
            var ani = cc.Animation.create();
            cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/" + fileName + ".plist");
            for (var k = 1; k <= count; k++) {
                var pngstring = fileName + k + ".png";
                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
            }
            // 设置动画帧率
            ani.setDelayPerUnit(0.25);
            // 设置动画播放完毕后是否回到第一帧
            ani.setRestoreOriginalFrame(true);
            return new cc.Animate(ani);
        };
        SkillManager.g_instance = null;
        return SkillManager;
    }());
    game.SkillManager = SkillManager;
    var SkillStruct = (function () {
        //m_isSucceed :boolean = false
        function SkillStruct(typeName, _time, parent) {
            this.m_Type = null;
            this.m_Time = 0;
            this.m_curTime = 0;
            this.m_TargetLen = 0;
            this.m_curTarget = 0;
            this.m_parent = null;
            this.m_spineAnimate = null;
            this.m_Data = null; //下一个坐标的Node对象
            this.m_angle = 0;
            this.m_Type = SkillManager.getMe().getSkillTypeByTypeName(typeName);
            this.m_Time = _time;
            this.m_parent = parent;
            if (this.m_Type == e_skillType.e_jiasu) {
                this.m_spineAnimate = null;
            }
            else if (this.m_Type == e_skillType.e_shengzhang) {
                this.m_spineAnimate = null;
            }
            else if (this.m_Type == e_skillType.e_wudi) {
                this.m_spineAnimate = game.spineMgr.getMe().loadSpine("wudi", this.m_parent, 1000000);
                this.m_spineAnimate.setAnimation(0, "wudi", true);
            }
            else if (this.m_Type == e_skillType.e_touqie) {
                this.m_spineAnimate = null;
            }
            else if (this.m_Type == e_skillType.e_pengzhang) {
                this.m_spineAnimate = null;
            }
            else {
                this.m_spineAnimate = null; //spineMgr.getMe().loadSpine("texiaozheng1",this.m_parent , 1000000)
            }
            if (this.m_spineAnimate) {
                this.m_spineAnimate.setVisible(false);
            }
            // let actName = SkillManager.getMe().getAnimateNameByType( this.m_Type )
            // if( actName ){
            //     this.m_spineAnimate.setAnimation( 0, actName ,true)
            // }
        }
        SkillStruct.prototype.isComplete = function () {
            if (this.m_curTarget == 0) {
                return true;
            }
            return false;
        };
        SkillStruct.prototype.setPos = function (p) {
            this.m_spineAnimate.setPosition(p);
        };
        SkillStruct.prototype.setAngle = function (angle) {
            this.m_angle = angle;
            this.m_spineAnimate.setRotation(angle);
        };
        SkillStruct.prototype.stop = function () {
            this.m_curTime = 0;
            if (this.m_spineAnimate) {
                this.m_spineAnimate.setVisible(false);
            }
            //this.m_TargetLen = 0
            //this.m_parent.stopAction(this.m_animate)
        };
        SkillStruct.prototype.run = function () {
            if (this.m_spineAnimate) {
                this.m_spineAnimate.setVisible(true);
            }
        };
        SkillStruct.prototype.shutDown = function () {
            if (this.m_spineAnimate) {
                this.m_parent.removeChild(this.m_spineAnimate.getNode());
                this.m_spineAnimate = null;
            }
        };
        return SkillStruct;
    }());
    game.SkillStruct = SkillStruct;
    var node = (function () {
        function node() {
            this.m_spr = null;
            this.m_next = null;
            this.m_last = null;
            this.m_zOrder = 0;
            this.m_walkSpeek = 0;
            this.m_id = 0;
            this.m_parent = null;
            this.m_arrPos = new Array();
            this.m_spr = null;
            this.m_next = null;
            this.m_last = null;
        }
        node.prototype.shutdown = function () {
            this.m_arrPos.length = 0;
            //this.m_parent.removeChild(this.m_spr)
            this.m_spr = null;
        };
        node.prototype.push_Front_Ex = function (Tagpos, speed, dir) {
            for (var k = 1; k <= speed; k++) {
                var p = cc.pAdd(Tagpos, cc.pMult(dir, k));
                this.push_front(p);
            }
        };
        node.prototype.push_front = function (pos) {
            this.m_arrPos.unshift(pos); //默认头部插入
        };
        node.prototype.getradius = function () {
            //大概半径
            var size = this.m_spr.getBoundingBox();
            return (size.width + size.height) / 6;
        };
        node.prototype.reset = function () {
            this.m_arrPos.length = 0;
            this.m_spr = null;
        };
        node.prototype.popPos_Ex = function (s) {
            var p = null;
            for (var k = 0; k < s; k++) {
                p = this.m_arrPos.pop();
                if (this.m_next) {
                    this.m_next.push_front(p);
                }
            }
            return p;
        };
        node.prototype.popPos = function () {
            var p = this.m_arrPos.pop();
            return p;
        };
        node.prototype.getPos = function () {
            return this.m_spr.getPosition();
        };
        node.prototype.setAngle = function (angle) {
            this.m_spr.setRotation(angle);
        };
        node.prototype.getAngle = function () {
            return this.m_spr.getRotation();
        };
        node.prototype.setPos = function (pos) {
            this.m_spr.setPosition(pos);
        };
        node.prototype.getZ = function () {
            return this.m_zOrder;
        };
        node.prototype.getRearNodeByNum = function (num) {
            var result = this;
            if (num > 0) {
                for (var k = 0; k < num; k++) {
                    result = result.m_next;
                    if (result == null) {
                        return result;
                    }
                }
            }
            else {
                for (var k = 0; k < Math.abs(num); k++) {
                    result = result.m_last;
                    if (result == null) {
                        return result;
                    }
                }
            }
            return result;
        };
        node.prototype.init = function (pos, dir, parent, isHead) {
            if (isHead === void 0) { isHead = false; }
            if (isHead) {
                this.m_zOrder = 10000;
                this.m_spr.setLocalZOrder(this.m_zOrder);
                this.setPos(pos);
            }
            else {
                var lastPos = this.m_last.getPos();
                dir = cc.pNormalize(dir);
                for (var j = game.g_Snake_Config.interval; j > 0; j--) {
                    var p = cc.pAdd(lastPos, cc.pMult(dir, j));
                    this.push_front(p);
                }
                this.setPos(this.popPos());
                this.m_zOrder = this.m_last.getZ() - 1;
            }
            this.m_parent = parent;
            //this.m_parent.addChild( this.m_spr , this.m_zOrder)
            this.m_id = (this.m_last == null ? 1 : this.m_last.m_id + 1);
        };
        return node;
    }());
    game.node = node;
    ;
    var nodeEx = (function () {
        function nodeEx(_node, _spr, parent, action) {
            this.m_node = null;
            this.m_sprite = null;
            this.m_parent = null;
            this.m_isComplete = false;
            this.m_node = _node;
            this.m_sprite = _spr;
            this.m_parent = parent;
            this.m_sprite.setPosition(this.m_node.getPos());
            this.m_parent.addChild(this.m_sprite);
            this.m_sprite.runAction(action);
        }
        nodeEx.prototype.shutdown = function () {
            if (this.m_sprite) {
                this.m_sprite.stopAllActions();
                this.m_parent.removeChild(this.m_sprite);
                this.m_sprite = null;
            }
        };
        nodeEx.prototype.update = function (t, isRotation) {
            if (isRotation === void 0) { isRotation = false; }
            if (this.m_node != null && this.m_node.m_spr != null) {
                this.m_sprite.setPosition(this.m_node.getPos());
                if (isRotation) {
                    this.m_node.setAngle(this.m_node.getAngle() + 10);
                }
                this.m_sprite.setRotation(this.m_node.getAngle() + 180);
                if (this.m_node.getRearNodeByNum(1) != null) {
                    this.m_node = this.m_node.getRearNodeByNum(1);
                    return true;
                }
                else {
                    this.shutdown();
                    this.m_isComplete = true;
                    return false;
                }
            }
            else {
                this.shutdown();
                this.m_isComplete = true;
                return false;
            }
        };
        return nodeEx;
    }());
    game.nodeEx = nodeEx;
    var fourSearchNode = (function () {
        function fourSearchNode(beginId, endId, point) {
            this.m_curId = 0;
            this.m_endId = 0;
            this.m_Point = null;
            this.m_Complete = false;
            this.m_curId = beginId;
            this.m_endId = endId;
            this.m_Point = point;
        }
        fourSearchNode.create = function (beginId, endId, point) {
            return new fourSearchNode(beginId, endId, point);
        };
        fourSearchNode.prototype.isComplete = function () {
            return this.m_Complete;
        };
        fourSearchNode.prototype.setComplete = function () {
            this.m_Point = null;
            this.m_Complete = true;
        };
        fourSearchNode.prototype.toNext = function () {
            if (this.m_Point && this.m_Point.m_next && this.m_curId < this.m_endId) {
                this.m_Point = this.m_Point.m_next;
                ++this.m_curId;
            }
            else {
                this.m_Point = null;
                this.m_Complete = true;
            }
        };
        return fourSearchNode;
    }());
    game.fourSearchNode = fourSearchNode;
    var baseRole = (function (_super) {
        __extends(baseRole, _super);
        //m_SpingNode:cc.Node = null
        function baseRole() {
            _super.call(this);
            this.m_name = "";
            this.m_res = "";
            this.m_birth = cc.p(0, 0); //出生坐标，蛇头的
            this.m_roledir = -1;
            this.m_EventEmitter = null;
            this.m_StateControl = null; //状态机
            this.m_WalkSpeed = 1; //移速，只能是1的倍速
            this.m_dir = cc.p(-1, 0);
            this.m_curLength = 0; //当前蛇的长度
            this.m_scale = 1; //缩放
            this.m_mingci = 0; //当前名次
            this.m_head = null; //蛇头
            this.m_tail = null; //蛇尾
            this.m_BodyNode = null;
            this.m_TailNode = null;
            //m_pifuName:string = null    //当前使用的皮肤
            this.m_Type = null;
            this.m_skinConfig = null;
            this.m_foodList = null;
            this.m_headShow = null;
            this.m_killnum = 0;
            this.m_killedName = null;
            this.m_bestLen = 0;
            this.m_score = 0;
            this.m_aureole = null; //出生光环
            this.m_skillNode = null; //技能对象
            //m_skillParentNode:cc.Sprite = null    //技能父节点
            this.m_isSpeedUp = false; //加速状态
            this.m_isShengzhang = false; //生长状态
            this.m_isQiequ = false; //窃取状态
            this.m_isPengzhang = false; //彭账状态
            this.m_isYinshen = false; //隐身状态
            this.m_isWudi = false; //无敌状态
            this.m_isJianSu = false; //减速状态
            this.m_jianSuBuffTime = 0;
            this.m_skill_num = 0; //技能数
            this.m_skill_Time = 0; //技能持续 时间
            this.m_skill_ISRelease = false; //当前是否释放 技能
            this.m_skill_isEndRelease = false; //当前技能是回收状态
            this.m_isAuto = false; //自动状态
            this.m_qiequList = null;
            //m_Speed_Up_Node:cc.Sprite = null
            this.m_Control_angle = 0; //  可操纵角度
            this.m_GameTime = 0;
            this.m_bigEnergy = 0;
            this.m_otherNode = null;
            this.m_otherNodeList = null;
            this.m_skillMoveTime = 1;
            this.m_isSuicide = false; //是否自杀
            this.m_isSetAngle = false; //是否可设置角度
        }
        baseRole.prototype.setName = function (name) {
            this.m_name = name;
        };
        baseRole.prototype.getName = function () {
            return this.m_name;
        };
        baseRole.prototype.setMingci = function (mingci) {
            this.m_mingci = mingci;
        };
        baseRole.prototype.getMingci = function () {
            return this.m_mingci;
        };
        baseRole.prototype.initlizi = function () {
            this.m_otherNode = new cc.Node();
            this.m_otherNode.setPosition(cc.p(0, 0));
            this.addChild(this.m_otherNode, 10000000);
            this.m_otherNodeList = new Array();
            this.m_aureole = cc.Sprite.create("xingjietanshishe/big/ui/image/wudi.png");
            this.m_aureole.setScale(0.5);
            this.m_aureole.setPosition(-500, -500);
            this.m_aureole.setVisible(false);
            this.addChild(this.m_aureole, -10000);
            this.m_skillMoveTime = 1;
        };
        baseRole.prototype.initSkill = function () {
            this.m_isSpeedUp = false; //加速状态
            this.m_isShengzhang = false; //生长状态
            this.m_isQiequ = false; //窃取状态
            this.m_isPengzhang = false; //彭账状态
            this.m_isYinshen = false; //隐身状态
            this.m_isWudi = false; //无敌状态
            this.m_isJianSu = false; //减速状态
            this.m_skillNode = new SkillStruct(this.m_skinConfig["skill"], this.m_skinConfig["skilltime"], this.getNode());
            this.m_skill_Time = this.m_skinConfig["skilltime"];
            this.m_skill_ISRelease = false;
            this.m_skill_isEndRelease = false;
            this.m_skill_num = this.m_skinConfig["skillnum"];
            this.m_qiequList = new Array();
            this.m_jianSuBuffTime = 0;
            if (this.m_Type == game.g_ObjType.play) {
                console.log(this.m_skinConfig["skill"] + "....skillName....");
            }
        };
        baseRole.prototype.setControl_angle = function (angle) {
            if (this.m_Type == game.g_ObjType.play) {
                this.m_Control_angle = game.DataMgr.getMe().setPlaycontrol_angle(angle);
            }
        };
        baseRole.prototype.initSnake = function (skinname, initLen) {
            if (initLen === void 0) { initLen = 0; }
            this.m_GameTime = 0;
            this.m_Control_angle = game.g_player_Config.g_Control_angle;
            if (this.m_Type == game.g_ObjType.play) {
                this.m_Control_angle = game.DataMgr.getMe().getPlaycontrol_angle();
            }
            var T_node = game.UiBase.parseUiFile_static("id.json");
            this.m_headShow = T_node.getChildByName("Text_1");
            T_node.removeAllChildren();
            this.m_headShow.setString(this.m_name);
            this.m_headShow.setPosition(cc.pAdd(this.m_birth, cc.p(0, 40)));
            this.addChild(this.m_headShow, 10000000);
            this.m_foodList = new Array();
            this.m_EventEmitter = new game.EventEmitter();
            this.m_scale = game.g_Snake_Config.Body_scale;
            //this.m_Speed_Up_Node = new cc.Sprite()
            this.m_skinConfig = game.DataMgr.getMe().getSkinConfigByName(skinname);
            this.m_WalkSpeed = game.g_Snake_Config.Speed;
            this.m_BodyNode = cc.SpriteBatchNode.create(this.m_skinConfig["sprite_body"]);
            this.m_TailNode = cc.Sprite.create(this.m_skinConfig["sprite_tail"]);
            this.m_isSpeedUp = false;
            this.m_isShengzhang = false;
            this.m_isQiequ = false;
            this.m_isPengzhang = false;
            this.m_isYinshen = false;
            this.m_isWudi = false;
            this.m_isJianSu = false;
            if (this.m_BodyNode) {
                this.m_BodyNode.setPosition(cc.p(0, 0));
                this.addChild(this.m_BodyNode, 2);
            }
            if (this.m_TailNode) {
                this.m_TailNode.setPosition(cc.p(0, 0));
                this.m_TailNode.setScale(0.5);
                this.addChild(this.m_TailNode, -1);
            }
            if (initLen == 0) {
                for (var j = 0; j < game.g_Snake_Config.Length; j++) {
                    this.addSnakeLen();
                }
            }
            else {
                for (var j = 0; j < initLen; j++) {
                    this.addSnakeLen();
                }
            }
            this.m_score = game.g_scoreMgr.getScorebyLen(this.m_curLength);
            //初始粒子
            this.initlizi();
            this.initSkill();
        };
        baseRole.prototype.addscore = function (score) {
            this.m_score += score;
            if (game.g_scoreMgr.getLenbyScore(this.m_score) > this.m_curLength) {
                this.addSnakeLen();
            }
        };
        baseRole.prototype.setAlpha = function (alpha) {
            for (var k = this.m_head; k != null; k = k.m_next) {
                k.m_spr.opacity = alpha;
            }
        };
        baseRole.prototype.addFood = function (food) {
            if (this.inFoodList(food)) {
                return;
            }
            else {
                var movefood = game.food_move.creat(this.m_head.m_spr, food);
                this.m_foodList.push(movefood);
            }
        };
        baseRole.prototype.inFoodList = function (food) {
            for (var j = 0; j < this.m_foodList.length; j++) {
                if (food.m_id == this.m_foodList[j].m_curobj.m_id) {
                    return true;
                }
            }
            return false;
        };
        baseRole.prototype.foodUpdate = function (t) {
            for (var j = 0; j < this.m_foodList.length;) {
                if (this.m_foodList[j].m_succeed) {
                    var obj = this.m_foodList.splice(j, 1)[0];
                    this.addscore(obj.m_score);
                    game.mapGezi.getMe().deleteByObj(obj.m_curobj);
                }
                else {
                    this.m_foodList[j++].update(this.m_WalkSpeed + Math.floor(t * 100));
                }
            }
        };
        //换个名字换身皮肤换个坐标
        baseRole.prototype.renameStart = function () {
            this.setVisible(true);
            var _len = game.g_scoreMgr.getLenbyScore(this.m_score / 2);
            var _skinName = this.m_skinConfig.name;
            this.shutdown();
            this.m_birth.x = game.g_map_config.border_width * 2 + Math.floor(Math.random() * (game.g_map_config.map_width / 2));
            if (_len > 5) {
                this.initSnake(_skinName, _len);
            }
            else {
                this.initSnake(_skinName);
            }
        };
        baseRole.prototype.reStart = function () {
        };
        baseRole.prototype.setRunDir = function (dir) {
            this.m_dir = dir;
        };
        baseRole.prototype.getRunDir = function () {
            return this.m_dir;
        };
        baseRole.prototype.getCurWalkSpeed = function () {
            return this.m_WalkSpeed;
        };
        baseRole.prototype.shutdown = function () {
            this.m_EventEmitter.emit("exit");
            this.m_curLength = 0;
            this.m_skinConfig = null;
            this.m_foodList.length = 0;
            this.m_mingci = 0;
            this.m_killnum = 0;
            this.m_killedName = null;
            this.m_bestLen = 0;
            this.m_score = 0;
            this.m_isSuicide = false;
            if (this.m_otherNodeList.length != 0) {
                for (var k = 0; k < this.m_otherNodeList.length;) {
                    this.m_otherNodeList[k].shutdown();
                    this.m_otherNodeList.splice(0, 1);
                }
                this.m_otherNodeList.length = 0;
                this.m_otherNodeList = null;
            }
            if (this.m_otherNode) {
                this.m_otherNode.removeAllChildren();
                this.removeChild(this.m_otherNode);
                this.m_otherNode = null;
            }
            if (this.m_qiequList.length != 0) {
                for (var k = 0; k < this.m_qiequList.length; k++) {
                    this.m_qiequList[k].shutdown();
                }
                this.m_qiequList.length = 0;
            }
            if (this.m_skillNode) {
                this.m_skillNode.shutDown();
                //this.removeChild(this.m_skillParentNode)
                this.m_skillNode = null;
            }
            if (this.m_headShow) {
                this.removeChild(this.m_headShow);
                this.m_headShow = null;
            }
            if (this.m_head.m_spr) {
                this.removeChild(this.m_head.m_spr);
            }
            // if(this.m_Speed_Up_Node){
            //     this.removeChild(this.m_Speed_Up_Node)
            //     this.m_Speed_Up_Node = null
            // }
            if (this.m_aureole) {
                this.removeChild(this.m_aureole);
                this.m_aureole = null;
            }
            if (this.m_BodyNode) {
                this.m_BodyNode.removeAllChildren();
                this.removeChild(this.m_BodyNode);
                this.m_BodyNode = null;
            }
            if (this.m_TailNode) {
                this.m_TailNode.removeAllChildren();
                this.removeChild(this.m_TailNode);
                this.m_TailNode = null;
            }
            for (var n = this.m_head; n != null;) {
                var n_next = n.m_next;
                n.shutdown();
                n = n_next;
            }
            this.m_head = null;
            this.m_tail = null;
        };
        baseRole.prototype.isPlay = function () {
            return true;
        };
        baseRole.prototype.is_head = function (obj) {
            if (obj === this.m_head) {
                return true;
            }
            return false;
        };
        baseRole.prototype.is_tail = function (obj) {
            if (obj === this.m_tail) {
                return true;
            }
            return false;
        };
        baseRole.prototype.getMiddleBody = function () {
            var data = this.m_head;
            for (var k = 0; k < this.m_curLength / 2; k++) {
                data = data.m_next;
            }
            return data;
        };
        baseRole.prototype.addSnakeLen = function () {
            var newNode = new node();
            newNode.m_walkSpeek = this.m_WalkSpeed;
            var spr = null;
            if (this.m_head == null) {
                spr = cc.Sprite.create(this.m_skinConfig["sprite_head"]);
                newNode.m_spr = spr;
                this.m_head = newNode;
                this.m_head.m_next = null;
                this.m_head.m_last = null;
                this.m_tail = this.m_head;
                this.m_tail.m_next = null;
                this.m_head.init(this.m_birth, null, this, true);
                this.addChild(newNode.m_spr, newNode.getZ());
                this.m_head.m_spr.setScale(game.g_snake_len_Config[0].scale);
            }
            else {
                //即将超出边界不增加长度
                // if( this.m_tail != null &&
                //     this.m_tail.getPos().x > g_map_config.border_width - g_map_config.border_width - 50 ){
                //     return
                // }
                spr = new cc.Sprite(this.m_BodyNode.getTexture());
                newNode.m_spr = spr;
                this.m_tail.m_next = newNode;
                newNode.m_last = this.m_tail;
                this.m_tail = newNode;
                this.m_tail.m_next = null;
                var dir = cc.p(game.g_Snake_Config.interval, 0);
                if (this.m_curLength > game.g_Snake_Config.Length) {
                    dir = cc.pNormalize(cc.pSub(newNode.m_last.getPos(), newNode.m_last.m_last.getPos()));
                }
                this.m_tail.init(null, dir, this.m_BodyNode);
                this.m_BodyNode.addChild(spr, newNode.getZ());
                newNode.m_spr.setScale(this.m_scale);
            }
            this.m_TailNode.setScale(this.m_scale);
            this.m_TailNode.setPosition(spr.getPosition());
            this.setAngel(newNode);
            ++this.m_curLength;
            for (var k = 0; k < game.g_snake_len_Config.length - 1; k++) {
                if (this.m_curLength > game.g_snake_len_Config[k].len && this.m_curLength < game.g_snake_len_Config[k + 1].len) {
                    if (this.m_scale != game.g_snake_len_Config[k].scale) {
                        this.m_scale = game.g_snake_len_Config[k].scale;
                        this.scaleSnake(this.m_scale);
                    }
                }
                else {
                    this.m_scale = game.g_snake_len_Config[0].scale;
                }
            }
            this.m_bestLen = this.m_curLength > this.m_bestLen ? this.m_curLength : this.m_bestLen;
            this.m_bigEnergy = game.g_scoreMgr.getAddScoreBylen(this.m_curLength);
        };
        baseRole.prototype.subSnakeLen = function () {
            if (this.m_curLength < 10) {
                return false;
            }
            var n = this.m_tail.m_last;
            this.m_BodyNode.removeChild(this.m_tail.m_spr);
            this.m_tail.shutdown();
            this.m_tail = n;
            this.m_tail.m_next = null;
            this.m_score = game.g_scoreMgr.getScorebyLen(--this.m_curLength);
            for (var k = 0; k < game.g_snake_len_Config.length - 1; k++) {
                if (this.m_curLength > game.g_snake_len_Config[k].len && this.m_curLength < game.g_snake_len_Config[k + 1].len) {
                    if (this.m_scale != game.g_snake_len_Config[k].scale) {
                        this.m_scale = game.g_snake_len_Config[k].scale;
                        this.scaleSnake(this.m_scale);
                    }
                }
                else {
                    this.m_scale = game.g_snake_len_Config[0].scale;
                }
            }
        };
        baseRole.prototype.scaleSnake = function (scale) {
            for (var n = this.m_head; n != null; n = n.m_next) {
                n.m_spr.setScale(scale);
            }
            this.m_head.m_spr.setScale(scale);
            this.m_TailNode.setScale(scale);
        };
        baseRole.prototype.getSnakeLength = function () {
            return Math.ceil(this.m_score);
            //return this.m_curLength
        };
        baseRole.prototype.getHeadPos = function () {
            return this.m_head.getPos();
        };
        baseRole.prototype.getTailPos = function () {
            return this.m_tail.getPos();
        };
        baseRole.prototype.getTailByNodeId = function (id) {
            var n = this.m_head;
            while (n) {
                if (n.m_id == id) {
                    return n;
                }
                n = n.m_next;
            }
            return null;
        };
        baseRole.prototype.fourSearch = function (search_depth, callback, point) {
            //node的id从1开始
            var unitLen = Math.ceil(this.m_curLength / search_depth);
            var SearchArray = new Array();
            for (var SearchNum = 1; SearchNum <= search_depth; SearchNum++) {
                if (SearchNum == 1) {
                    var _endId = unitLen;
                    SearchArray.push(fourSearchNode.create(1, _endId, this.m_head));
                }
                else {
                    var _beginId = SearchArray[SearchNum - 2].m_endId + 1;
                    var _endId = unitLen * SearchNum;
                    SearchArray.push(fourSearchNode.create(_beginId, _endId, this.getTailByNodeId(_beginId)));
                }
            }
            var isComplete = false;
            while (true) {
                if (isComplete || callback.call(point, SearchArray)) {
                    SearchArray.length = 0;
                    break;
                }
                var isOk = true;
                for (var k = 0; k < SearchArray.length; k++) {
                    if (!SearchArray[k].isComplete()) {
                        SearchArray[k].toNext();
                        isOk = false;
                    }
                }
                isComplete = isOk;
            }
        };
        baseRole.prototype.getDropPoint = function (func) {
            //死亡状态时获取
            for (var n = this.m_head; n != null; n = n.m_next) {
                func(cc.pAdd(n.getPos(), cc.p(Math.random() * 40 - 20, Math.random() * 40 - 20)), game.getBigFood_Rand().type);
            }
        };
        baseRole.prototype.runSkill = function () {
            if (this.m_Type == game.g_ObjType.monster) {
                this.m_skill_num = 1;
            }
            else if (game.g_gameVersion === game.e_game_Version.e_money && this.m_skill_num <= 0 && !this.m_skill_ISRelease) {
                if (game.DataMgr.getMe().getzuansiNum() >= 20) {
                    this.m_skill_num = 1;
                    game.DataMgr.getMe().subZuansiNum(20);
                }
            }
            if (!this.m_skill_ISRelease && this.m_skill_num > 0 && !this.m_skill_isEndRelease) {
                this.m_skill_ISRelease = true;
                this.m_skill_num--;
                this.m_skillNode.run();
                if (this.m_skillNode.m_Type != e_skillType.e_jiasu) {
                    this.m_WalkSpeed = game.g_Snake_Config.skillUpSpeed;
                }
                switch (this.m_skillNode.m_Type) {
                    case e_skillType.e_jiasu:
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/jiasu.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible( false )
                        this.m_isSpeedUp = true;
                        break;
                    case e_skillType.e_shengzhang:
                        this.m_skillNode.m_curTime = 1.1;
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/shengzhang.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible( false )
                        this.m_skillNode.m_TargetLen = game.g_scoreMgr.getLenbyScore(this.m_skinConfig["skillpower"] * this.m_score + this.m_score);
                        this.m_isShengzhang = true;
                        break;
                    case e_skillType.e_touqie:
                        this.m_skillNode.m_curTime = 1.1;
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/qiequ.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        //this.m_skillNode.m_spineAnimate.setScale( this.m_scale * 5 )
                        this.m_isQiequ = true;
                        break;
                    case e_skillType.e_dilei:
                        new game.role_dilei(this.m_skinConfig["kuang_icon"], null, this.getName(), this.getNode(), this.m_TailNode.getPosition());
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        this.m_isJianSu = true;
                        break;
                    case e_skillType.e_pengzhang:
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/jiasude1.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        this.m_skillNode.m_TargetLen = game.g_scoreMgr.getLenbyScore(this.m_skinConfig["skillpower"] * this.m_score + this.m_score);
                        this.m_isPengzhang = true;
                        break;
                    case e_skillType.e_yinshen:
                        //怪物隐身
                        if (this.m_Type == game.g_ObjType.monster) {
                            //this.getNode().opacity = 255
                            //this.getNode().runAction(cc.fadeIn(0.5))
                            this.setVisible(false);
                        }
                        else {
                            //this.setAlpha( 50 )
                            this.getNode().opacity = 50;
                        }
                        this.m_isYinshen = true;
                        break;
                    case e_skillType.e_wudi:
                        this.m_skillNode.m_spineAnimate.setScale(0.1);
                        this.m_skillNode.setPos(cc.p(0, 0));
                        this.m_skillNode.setAngle(this.m_head.getAngle() + 180);
                        this.m_isWudi = true;
                        break;
                    default:
                        console.log("没有这个状态。。。");
                        break;
                }
            }
            else {
            }
        };
        baseRole.prototype.Skill_end = function () {
            this.m_skillNode.stop();
            this.m_WalkSpeed = game.g_Snake_Config.Speed;
            switch (this.m_skillNode.m_Type) {
                case e_skillType.e_jiasu:
                    for (var k = 0; k < this.m_otherNodeList.length;) {
                        var n = this.m_otherNodeList[k];
                        if (n.m_sprite) {
                            n.shutdown();
                        }
                        this.m_otherNodeList.splice(k, 1);
                    }
                    this.m_isSpeedUp = false;
                    this.m_WalkSpeed = game.g_Snake_Config.Speed;
                    this.m_skill_isEndRelease = false;
                    break;
                case e_skillType.e_shengzhang:
                    for (var k = 0; k < this.m_otherNodeList.length;) {
                        var n = this.m_otherNodeList[k];
                        if (n.m_sprite) {
                            n.shutdown();
                        }
                        this.m_otherNodeList.splice(k, 1);
                    }
                    this.m_skillNode.m_curTarget = 0;
                    this.m_isShengzhang = false;
                    this.m_skill_isEndRelease = false;
                    break;
                case e_skillType.e_touqie:
                    for (var k = 0; k < this.m_otherNodeList.length;) {
                        var n = this.m_otherNodeList[k];
                        if (n.m_sprite) {
                            n.shutdown();
                        }
                        this.m_otherNodeList.splice(k, 1);
                    }
                    this.m_isQiequ = false;
                    this.m_skill_isEndRelease = false;
                    break;
                case e_skillType.e_dilei:
                    this.m_isJianSu = false;
                    this.m_skill_isEndRelease = false;
                    break;
                case e_skillType.e_pengzhang:
                    for (var k = 0; k < this.m_otherNodeList.length;) {
                        var n = this.m_otherNodeList[k];
                        if (n.m_sprite) {
                            n.shutdown();
                        }
                        this.m_otherNodeList.splice(k, 1);
                    }
                    this.m_isPengzhang = false;
                    if (this.m_skillNode.m_curTarget > 0) {
                        this.subSnakeLen();
                        --this.m_skillNode.m_curTarget;
                    }
                    else {
                        this.m_skill_isEndRelease = false;
                    }
                    break;
                case e_skillType.e_yinshen:
                    if (this.m_Type == game.g_ObjType.monster) {
                        //this.getNode().runAction(cc.fadeIn(0.5))
                        this.setVisible(true);
                    }
                    else {
                        //this.getNode().opacity
                        this.setAlpha(255);
                    }
                    this.m_isYinshen = false;
                    this.m_skill_isEndRelease = false;
                    break;
                case e_skillType.e_wudi:
                    this.m_isWudi = false;
                    this.m_skill_isEndRelease = false;
                    break;
                default:
                    this.m_isQiequ = false;
                    this.m_isSpeedUp = false;
                    this.m_isJianSu = false;
                    this.m_isPengzhang = false;
                    this.m_isYinshen = false;
                    this.m_isWudi = false;
                    this.m_skill_isEndRelease = false;
                    console.log("没有这个状态。。。");
                    break;
            }
            if (this.m_skillNode.m_spineAnimate) {
                this.m_skillNode.m_spineAnimate.setVisible(false);
            }
            return false;
        };
        baseRole.prototype.Skill_qiequ = function (tailNode, point) {
            if (this.m_skillNode.m_curTime > 1) {
                var ani = cc.Animation.create();
                for (var k = 0; k <= 9; k++) {
                    var pngstring = k + ".png";
                    ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                }
                // 设置动画帧率
                ani.setDelayPerUnit(0.02);
                // 设置动画播放完毕后是否回到第一帧
                ani.setRestoreOriginalFrame(true);
                var animate_ = new cc.Animate(ani);
                var spr = cc.Sprite.create();
                spr.setScale(this.m_scale * 2);
                this.m_otherNodeList.push(new nodeEx(this.m_head, spr, this.m_otherNode, cc.repeatForever(animate_)));
                this.m_skillNode.m_curTime = 0;
                var n = tailNode;
                this.m_skillNode.m_TargetLen = Math.ceil(point.m_curLength * (this.m_skinConfig["skillpower"]));
                for (var k = 0; k < this.m_skillNode.m_TargetLen; k++) {
                    this.m_qiequList.push(new game.RoleQiequ(n.getPos(), this.getNode(), this.m_head));
                    point.subSnakeLen();
                    this.addscore(3);
                    n = n.getRearNodeByNum(-5);
                    if (n == null) {
                        return;
                    }
                }
            }
            else {
                return;
            }
        };
        baseRole.prototype.Skill_update = function (t) {
            if (this.m_skillNode) {
                this.m_skillNode.m_curTime += t;
                //this.m_skillParentNode.setScale(this.m_scale)
                this.m_skill_Time -= t;
                if (this.m_skill_Time < 0.3) {
                    this.m_skill_Time = this.m_skillNode.m_Time;
                    this.m_skill_ISRelease = false;
                    this.m_skill_isEndRelease = true;
                    this.m_skillNode.stop();
                }
                switch (this.m_skillNode.m_Type) {
                    case e_skillType.e_jiasu:
                        this.m_skillMoveTime += t;
                        if (this.m_skillMoveTime > 0.3) {
                            this.m_skillMoveTime = 0;
                            var ani = cc.Animation.create();
                            for (var k = 1; k <= 4; k++) {
                                var pngstring = "texiao_0" + k + ".png";
                                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani.setRestoreOriginalFrame(true);
                            var animate_ = new cc.Animate(ani);
                            var spr = cc.Sprite.create();
                            spr.setScale(this.m_scale / 2);
                            this.m_otherNodeList.push(new nodeEx(this.m_head, spr, this.m_otherNode, cc.repeatForever(animate_)));
                        }
                        for (var k = 0; k < this.m_otherNodeList.length; k++) {
                            if (!this.m_otherNodeList[k].m_isComplete) {
                                this.m_otherNodeList[k].update(t);
                            }
                        }
                        this.m_WalkSpeed = game.g_Snake_Config.accSpeed;
                        break;
                    case e_skillType.e_shengzhang:
                        this.m_skillMoveTime += t;
                        if (this.m_skillMoveTime > 0.3) {
                            this.m_skillMoveTime = 0;
                            var ani_shengzhang = cc.Animation.create();
                            for (var k = 0; k <= 5; k++) {
                                var pngstring = "h_n_fire" + k + ".png";
                                ani_shengzhang.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani_shengzhang.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani_shengzhang.setRestoreOriginalFrame(true);
                            var animate_shengzhang = new cc.Animate(ani_shengzhang);
                            var spr_shengzhang = cc.Sprite.create();
                            spr_shengzhang.setScale(this.m_scale);
                            this.m_otherNodeList.push(new nodeEx(this.m_head, spr_shengzhang, this.m_otherNode, cc.repeatForever(animate_shengzhang)));
                        }
                        if (this.m_skillNode.m_curTime > 1) {
                            this.m_skillNode.m_curTime = 0;
                            var NodeP = this.m_TailNode.getPosition();
                            if (NodeP.x >= game.g_map_config.border_width * 1.5 && NodeP.x < game.g_map_config.map_width - game.g_map_config.border_width * 1.5
                                && NodeP.y > game.g_map_config.border_height * 1.5 && NodeP.y < game.g_map_config.map_height - game.g_map_config.border_height * 1.5) {
                                for (var k = 0; k < Math.max(1, Math.ceil(this.m_skillNode.m_TargetLen / 5)); k++) {
                                    this.addscore(game.g_Snake_Config.big_energy);
                                }
                            }
                        }
                        for (var k = 0; k < this.m_otherNodeList.length; k++) {
                            if (!this.m_otherNodeList[k].m_isComplete) {
                                this.m_otherNodeList[k].update(t);
                            }
                        }
                        break;
                    case e_skillType.e_touqie:
                        for (var k = 0; k < this.m_otherNodeList.length; k++) {
                            if (!this.m_otherNodeList[k].m_isComplete) {
                                this.m_otherNodeList[k].update(t, true);
                            }
                        }
                        // this.m_skillNode.setPos(this.m_head.getPos())
                        // this.m_skillNode.setAngle( this.m_skillNode.m_angle + 10 )
                        break;
                    case e_skillType.e_dilei:
                        if (this.m_skillNode.m_curTime > 4) {
                            this.m_skillNode.m_curTime = 0;
                            //if( this.m_TailNode!= null )
                            new game.role_dilei(this.m_skinConfig["kuang_icon"], null, this.getName(), this.getNode(), this.m_TailNode.getPosition());
                        }
                        // this.m_skillNode.setPos(this.m_head.getPos())
                        // this.m_skillNode.setAngle(this.m_head.getAngle() + 180)
                        break;
                    case e_skillType.e_pengzhang:
                        this.m_skillMoveTime += t;
                        if (this.m_skillMoveTime > 0.3) {
                            this.m_skillMoveTime = 0;
                            var ani = cc.Animation.create();
                            for (var k = 1; k <= 6; k++) {
                                var pngstring = "jiansude_0" + k + ".png";
                                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani.setRestoreOriginalFrame(true);
                            var animate_ = new cc.Animate(ani);
                            var spr = cc.Sprite.create();
                            spr.setScale(this.m_scale);
                            this.m_otherNodeList.push(new nodeEx(this.m_head, spr, this.m_otherNode, cc.repeatForever(animate_)));
                        }
                        for (var k = 0; k < this.m_otherNodeList.length; k++) {
                            if (!this.m_otherNodeList[k].m_isComplete) {
                                this.m_otherNodeList[k].update(t);
                            }
                        }
                        if (this.m_curLength < this.m_skillNode.m_TargetLen) {
                            var NodeP = this.m_TailNode.getPosition();
                            if (NodeP.x >= game.g_map_config.border_width * 1.5 && NodeP.x < game.g_map_config.map_width - game.g_map_config.border_width * 1.5
                                && NodeP.y > game.g_map_config.border_height * 1.5 && NodeP.y < game.g_map_config.map_height - game.g_map_config.border_height * 1.5) {
                                //this.addSnakeLen()
                                this.addscore(this.m_bigEnergy);
                                this.m_skillNode.m_curTarget++;
                            }
                        }
                        break;
                    case e_skillType.e_yinshen:
                        break;
                    case e_skillType.e_wudi:
                        if (this.m_Type == game.g_ObjType.monster) {
                            if (game.roleMgr.getMe().getControlPlayer().getCurStateType() != game.g_AiType.g_AiType_wudi
                                && !game.roleMgr.getMe().getControlPlayer().m_isYinshen && this.m_skill_Time > 2) {
                                if (cc.pDistance(game.roleMgr.getMe().getControlPlayer().m_head.getPos(), this.m_head.getPos()) < 500) {
                                    var Angle = cc.pToAngle(this.m_dir) / Math.PI * 180;
                                    var newDir = cc.pNormalize(cc.pSub(game.roleMgr.getMe().getControlPlayer().m_head.getPos(), this.m_head.getPos()));
                                    var nangle = cc.pToAngle(newDir) / Math.PI * 180;
                                    if (nangle > Angle) {
                                        this.m_dir = cc.pForAngle((Angle + this.m_Control_angle / 2) * Math.PI / 180);
                                    }
                                    else {
                                        this.m_dir = cc.pForAngle((Angle - this.m_Control_angle / 2) * Math.PI / 180);
                                    }
                                }
                            }
                        }
                        this.m_skillNode.m_spineAnimate.setScale(this.m_scale * 5.125);
                        this.m_skillNode.setPos(this.m_head.getPos());
                        this.m_skillNode.setAngle(this.m_head.getAngle() + 180);
                        break;
                    default:
                        console.log("没有这个状态。。。");
                        break;
                }
            }
        };
        baseRole.prototype.collideWall = function () {
            var radius = this.m_head.getradius();
            if (this.getHeadPos().x - radius <= game.g_map_config.border_width || this.getHeadPos().x + radius > game.g_map_config.map_width - game.g_map_config.border_width
                || this.getHeadPos().y - radius <= game.g_map_config.border_height || this.getHeadPos().y + radius >= game.g_map_config.map_height - game.g_map_config.border_height) {
                this.m_killedName = null;
                return true;
            }
            return false;
        };
        baseRole.prototype.loop = function (t) {
            this.m_GameTime += t;
            this.m_dir = cc.pNormalize(this.m_dir);
            if (this.m_foodList.length != 0) {
                this.foodUpdate(t);
            }
            //技能 释放状态
            if (this.m_skill_ISRelease) {
                this.Skill_update(t);
            }
            //技能未回收完毕的情况下
            if (this.m_skill_isEndRelease) {
                this.Skill_end();
            }
            if (!this.m_isWudi
                && this.getCurStateType() != game.g_AiType.g_AiType_wudi
                && game.role_dileiMgr.getMe().getcurSize() != 0) {
                var colideNode = game.role_dileiMgr.getMe().colide(this.m_head);
                if (colideNode != null) {
                    if (colideNode.m_Relesename != this.getName()) {
                        this.m_killedName = colideNode.m_Relesename;
                        game.ui_fight.getMe().updateShowKill(colideNode.m_Relesename, colideNode.m_roleHeadimgPath, this.getName(), this.m_skinConfig["kuang_icon"]);
                        this.getDropPoint(game.mapGezi.getMe().addGeziObj.bind(game.mapGezi.getMe()));
                        this.changeState_Ex(game.g_AiType.g_AiType_dead);
                        colideNode.setBoom();
                        return;
                    }
                }
            }
            if (this.m_qiequList.length != 0) {
                for (var k = 0; k < this.m_qiequList.length;) {
                    if (this.m_qiequList[k].m_isComplete) {
                        this.m_qiequList[k].shutdown();
                        this.m_qiequList.splice(k, 1);
                    }
                    else {
                        this.m_qiequList[k].update(t, this.m_WalkSpeed);
                        k++;
                    }
                }
            }
        };
        ;
        baseRole.prototype.setAngel = function (obj) {
            if (this.is_head(obj)) {
                var angel = 90 + cc.pToAngle(this.m_dir) / Math.PI * 180;
                obj.setAngle(-angel);
            }
            else {
                var dir = (cc.Vec2.sub(obj.getPos(), obj.m_last.getPos())).normalize();
                var angel = 90 - cc.pToAngle(dir) / Math.PI * 180;
                if (this.is_tail(obj)) {
                    this.m_TailNode.setRotation(angel);
                }
                obj.setAngle(angel);
            }
        };
        baseRole.prototype.isdead = function () {
            if (this.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return true;
            }
            return false;
        };
        baseRole.prototype.getDis = function (pos) {
            //return cc.pDistance(this.getPosition(), pos);
            var ret = cc.pSub(this.getPosition(), pos);
            return Math.abs(ret.x);
        };
        baseRole.prototype.changeState = function (key, data) {
            if (data === void 0) { data = null; }
            this.m_StateControl.changeState_Ex(key, data);
        };
        baseRole.prototype.changeState_Ex = function (type) {
        };
        baseRole.prototype.getCurStateType = function () {
            return this.m_StateControl.getCurStateType();
        };
        return baseRole;
    }(game.baseObj));
    game.baseRole = baseRole;
})(game || (game = {}));
//# sourceMappingURL=baseRole.js.map