"use strict";
module game {

    import e_Type = behavior.e_Type;
    export enum e_skillType{
        e_jiasu,            //加速
        e_shengzhang,       //生长
        e_touqie,           //偷取 长度
        e_dilei,           //减速
        e_pengzhang,        //彭涨
        e_yinshen,          //隐身
        e_wudi,              //无敌
    }
    export class SkillManager{
        static g_instance = null
        static getMe():SkillManager{
            if(!SkillManager.g_instance){
                SkillManager.g_instance = new SkillManager()
            }
            return SkillManager.g_instance
        }
        getSkillTypeByTypeName( name:string ){
            switch (name){
                case "jiasu": return e_skillType.e_jiasu
                case "shengzhang" : return e_skillType.e_shengzhang
                case "qiequ" : return e_skillType.e_touqie
                case "dilei":return e_skillType.e_dilei
                case "pengzhang" : return e_skillType.e_pengzhang
                case "yinshen":return e_skillType.e_yinshen
                case "wudi":return e_skillType.e_wudi
                default:return null
            }
        }
        createAction( count:number,fileName:string){
            let ani = cc.Animation.create();
            cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/"+ fileName +".plist");
            for (let k = 1;k <= count;k++) {
                let pngstring = fileName + k + ".png"
                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
            }
            // 设置动画帧率
            ani.setDelayPerUnit(0.25);
            // 设置动画播放完毕后是否回到第一帧
            ani.setRestoreOriginalFrame(true);
            return new cc.Animate(ani)
        }
    }
    export class SkillStruct{
        m_Type:e_skillType = null
        m_Time:number = 0
        m_curTime:number = 0
        m_TargetLen:number = 0
        m_curTarget:number = 0
        m_parent:cc.Node = null
        m_spineAnimate:SkeletonAnimation_Ex = null
        m_Data:node = null  //下一个坐标的Node对象
        m_angle = 0
        //m_isSucceed :boolean = false
        constructor( typeName:string, _time:number , parent:cc.Node){
            this.m_Type = SkillManager.getMe().getSkillTypeByTypeName(typeName)
            this.m_Time = _time
            this.m_parent = parent

            if( this.m_Type == e_skillType.e_jiasu ){
                this.m_spineAnimate = null
                // this.m_spineAnimate = spineMgr.getMe().loadSpine("texiao3",this.m_parent , 1000000)
                // this.m_spineAnimate.setAnimation( 0, "texiao3" ,true)
            }
            else if(this.m_Type == e_skillType.e_shengzhang){
                this.m_spineAnimate = null
                // this.m_spineAnimate = spineMgr.getMe().loadSpine("texiaozheng1",this.m_parent , 1000000)
                // this.m_spineAnimate.setAnimation( 0, "texiaozheng1" ,true)
            }
            else if( this.m_Type == e_skillType.e_wudi  ){
                this.m_spineAnimate = spineMgr.getMe().loadSpine("wudi",this.m_parent , 1000000)
                this.m_spineAnimate.setAnimation( 0, "wudi" ,true)
            }
            else if( this.m_Type == e_skillType.e_touqie ){
                this.m_spineAnimate = null
                // this.m_spineAnimate = spineMgr.getMe().loadSpine("xisho",this.m_parent , 1000000)
                // this.m_spineAnimate.setAnimation( 0, "xisho" ,true)
            }
            else if( this.m_Type == e_skillType.e_pengzhang ){
                this.m_spineAnimate = null
                // this.m_spineAnimate = spineMgr.getMe().loadSpine("jiansude1",this.m_parent , 1000000)
                // this.m_spineAnimate.setAnimation( 0, "jiansude" ,true)
            }
            else{
                this.m_spineAnimate = null //spineMgr.getMe().loadSpine("texiaozheng1",this.m_parent , 1000000)
                //this.m_spineAnimate.setAnimation( 0, "texiaozheng2" ,true)
            }
            if(this.m_spineAnimate){
                this.m_spineAnimate.setVisible(false)
            }
            // let actName = SkillManager.getMe().getAnimateNameByType( this.m_Type )
            // if( actName ){
            //     this.m_spineAnimate.setAnimation( 0, actName ,true)
            // }
        }
        isComplete():boolean{
            if( this.m_curTarget == 0 ){
                return true
            }
            return false
        }
        setPos( p:cc.Vec2 ){
            this.m_spineAnimate.setPosition( p )
        }
        setAngle( angle ){
            this.m_angle = angle
            this.m_spineAnimate.setRotation( angle )
        }
        stop(){
            this.m_curTime = 0
            if(this.m_spineAnimate){
                this.m_spineAnimate.setVisible(false)
            }
            //this.m_TargetLen = 0
            //this.m_parent.stopAction(this.m_animate)
        }
        run(){
            if(this.m_spineAnimate){
                this.m_spineAnimate.setVisible( true )
            }
        }
        shutDown(){
            if(this.m_spineAnimate){
                this.m_parent.removeChild(this.m_spineAnimate.getNode())
                this.m_spineAnimate = null
            }
        }
    }
    export class node {
        m_arrPos:Array<cc.Vec2>
        m_spr:cc.Sprite = null
        m_next:node = null
        m_last:node = null
        m_zOrder = 0
        m_walkSpeek = 0
        m_id = 0
        m_parent:any = null
        constructor(){
            this.m_arrPos = new Array<cc.Vec2>()
            this.m_spr = null
            this.m_next = null
            this.m_last = null
        }
        shutdown( ){
            this.m_arrPos.length = 0
            //this.m_parent.removeChild(this.m_spr)
            this.m_spr = null
        }
        push_Front_Ex(Tagpos:cc.Vec2, speed:number,dir:cc.Vec2){
            for(let k = 1; k <= speed; k++){
                let p = cc.pAdd(Tagpos,cc.pMult(dir,k))
                this.push_front(p)
            }
        }
        push_front(pos:cc.Vec2){
            this.m_arrPos.unshift(pos);//默认头部插入
        }
        getradius(){
            //大概半径
            let size = this.m_spr.getBoundingBox()
            return (size.width + size.height) / 6
        }
        reset(){
            this.m_arrPos.length = 0
            this.m_spr = null
        }
        popPos_Ex( s : number ):cc.Vec2{
            let p = null
            for(let k = 0; k < s; k++){
                p = this.m_arrPos.pop();
                if(this.m_next){
                    this.m_next.push_front(p)
                }
            }
            return p;
        }
        popPos():cc.Vec2{
            let p = this.m_arrPos.pop();
            return p;
        }
        getPos():cc.Vec2{
            return this.m_spr.getPosition();
        }
        setAngle(angle){
            this.m_spr.setRotation(angle)
        }
        getAngle(){
            return this.m_spr.getRotation()
        }
        setPos(pos:cc.Vec2){
            this.m_spr.setPosition(pos);
        }
        getZ() {
            return this.m_zOrder
        }
        getRearNodeByNum( num:number ):node{
            let result:node = this
            if( num > 0){
                for(let k = 0; k < num; k++){
                    result = result.m_next
                    if(result == null){
                        return result
                    }
                }
            }else{
                for(let k = 0; k < Math.abs(num); k++){
                    result = result.m_last
                    if(result == null){
                        return result
                    }
                }
            }
            return result
        }
        init( pos:cc.Vec2  ,dir:cc.Vec2 ,parent:any , isHead = false){

            if ( isHead ){
                this.m_zOrder = 10000
                this.m_spr.setLocalZOrder(this.m_zOrder);
                this.setPos(pos);
            }
            else{
                let lastPos = this.m_last.getPos()
                dir = cc.pNormalize( dir )
                for(let j = g_Snake_Config.interval; j > 0 ; j--){
                    let p = cc.pAdd( lastPos , cc.pMult( dir ,j ))
                    this.push_front(p)
                }
                this.setPos( this.popPos() )
                this.m_zOrder = this.m_last.getZ() - 1
                //this.m_spr.setLocalZOrder(this.m_zOrder);
            }
            this.m_parent = parent
            //this.m_parent.addChild( this.m_spr , this.m_zOrder)
            this.m_id = ( this.m_last == null ? 1 : this.m_last.m_id + 1 )
        }
    };
    export class nodeEx{
        m_node:node = null
        m_sprite:cc.Sprite = null
        m_parent:cc.Node = null
        m_isComplete:boolean = false
        constructor( _node:node,_spr:cc.Sprite , parent:cc.Node,action){
            this.m_node = _node
            this.m_sprite = _spr
            this.m_parent = parent
            this.m_sprite.setPosition(this.m_node.getPos())
            this.m_parent.addChild( this.m_sprite )
            this.m_sprite.runAction(action)
        }
        shutdown(){
            if(this.m_sprite){
                this.m_sprite.stopAllActions()
                this.m_parent.removeChild( this.m_sprite )
                this.m_sprite = null
            }
        }
        update( t , isRotation = false ):boolean{
            if( this.m_node != null &&  this.m_node.m_spr != null ){
                this.m_sprite.setPosition( this.m_node.getPos())
                if( isRotation ){
                    this.m_node.setAngle(this.m_node.getAngle() + 10)
                }
                this.m_sprite.setRotation( this.m_node.getAngle() + 180  )
                if(this.m_node.getRearNodeByNum(1) != null ){
                    this.m_node = this.m_node.getRearNodeByNum(1)
                    return true
                }else{
                    this.shutdown()
                    this.m_isComplete = true
                    return false
                }
            }else{
                this.shutdown()
                this.m_isComplete = true
                return false
            }
        }
    }
    export class fourSearchNode{
        m_curId:number = 0
        m_endId:number = 0
        m_Point:node = null
        m_Complete:boolean = false
        static create(  beginId, endId, point:node  ):fourSearchNode{
            return new fourSearchNode(  beginId, endId, point  )
        }
        constructor( beginId, endId, point:node ){
            this.m_curId = beginId
            this.m_endId = endId
            this.m_Point = point
        }
        isComplete():boolean{
            return this.m_Complete
        }
        setComplete(){
            this.m_Point = null
            this.m_Complete = true
        }
        toNext(){
            if(this.m_Point && this.m_Point.m_next && this.m_curId < this.m_endId){
                this.m_Point = this.m_Point.m_next
                ++this.m_curId
            }else{
                this.m_Point = null
                this.m_Complete = true
            }
        }
    }
    export class baseRole extends baseObj {
        m_name: string = "";
        m_res: string = "";
        m_birth: any = cc.p(0, 0)   //出生坐标，蛇头的
        m_roledir: number = -1;
        m_EventEmitter: EventEmitter = null;
        m_StateControl: baseStateControl = null;  //状态机
        m_WalkSpeed = 1   //移速，只能是1的倍速

        m_dir:cc.Vec2 = cc.p(-1,0)
        m_curLength = 0 //当前蛇的长度
        m_scale:number = 1;//缩放
        m_mingci:number = 0    //当前名次
        m_head:node = null;  //蛇头
        m_tail:node = null; //蛇尾

        m_BodyNode :cc.SpriteBatchNode = null
        m_TailNode :cc.Sprite = null
        //m_pifuName:string = null    //当前使用的皮肤
        m_Type: g_ObjType = null;
        m_skinConfig = null
        m_foodList:Array<food_move> = null
        m_headShow:ccui.Text = null
        m_killnum:number = 0
        m_killedName:string = null
        m_bestLen :number = 0
        m_score:number = 0

        m_aureole:cc.Sprite = null          //出生光环
        m_skillNode:SkillStruct = null      //技能对象
        //m_skillParentNode:cc.Sprite = null    //技能父节点

        m_isSpeedUp:boolean = false     //加速状态
        m_isShengzhang:boolean = false  //生长状态
        m_isQiequ:boolean = false       //窃取状态
        m_isPengzhang:boolean = false   //彭账状态
        m_isYinshen:boolean = false     //隐身状态
        m_isWudi:boolean = false        //无敌状态
        m_isJianSu:boolean = false      //减速状态

        m_jianSuBuffTime:number = 0

        m_skill_num:number = 0  //技能数
        m_skill_Time:number = 0 //技能持续 时间
        m_skill_ISRelease:boolean = false  //当前是否释放 技能
        m_skill_isEndRelease:boolean = false //当前技能是回收状态
        m_isAuto:boolean = false    //自动状态

        m_qiequList:Array<RoleQiequ> = null
        //m_Speed_Up_Node:cc.Sprite = null
        m_Control_angle:number = 0  //  可操纵角度
        m_GameTime:number = 0

        m_bigEnergy:number = 0
        m_otherNode:cc.Node = null
        m_otherNodeList:Array<nodeEx> = null
        m_skillMoveTime:number = 1

        m_isSuicide:boolean = false //是否自杀
        m_isSetAngle:boolean = false //是否可设置角度
        //m_SpingNode:cc.Node = null
        constructor() {
            super();
        }
        setName( name:string ){
            this.m_name = name
        }
        getName():string{
            return this.m_name
        }
        setMingci( mingci :number){
            this.m_mingci = mingci
        }
        getMingci():number{
            return this.m_mingci
        }
        initlizi(){

            this.m_otherNode = new cc.Node()
            this.m_otherNode.setPosition(cc.p(0,0))
            this.addChild(this.m_otherNode,10000000)
            this.m_otherNodeList = new Array<nodeEx>()

            this.m_aureole = cc.Sprite.create("xingjietanshishe/big/ui/image/wudi.png")
            this.m_aureole.setScale( 0.5 )
            this.m_aureole.setPosition( - 500, - 500 )
            this.m_aureole.setVisible( false )
            this.addChild( this.m_aureole , -10000 )

            this.m_skillMoveTime = 1

        }
        initSkill(){

            this.m_isSpeedUp = false     //加速状态
            this.m_isShengzhang = false  //生长状态
            this.m_isQiequ = false       //窃取状态
            this.m_isPengzhang = false   //彭账状态
            this.m_isYinshen = false     //隐身状态
            this.m_isWudi = false        //无敌状态
            this.m_isJianSu = false      //减速状态

            this.m_skillNode = new SkillStruct( this.m_skinConfig["skill"],this.m_skinConfig["skilltime"] ,this.getNode())
            this.m_skill_Time = this.m_skinConfig["skilltime"]
            this.m_skill_ISRelease = false
            this.m_skill_isEndRelease = false
            this.m_skill_num = this.m_skinConfig["skillnum"]

            this.m_qiequList = new Array<RoleQiequ>()
            this.m_jianSuBuffTime = 0
            if( this.m_Type == g_ObjType.play ){
                console.log( this.m_skinConfig["skill"] + "....skillName....")
            }

        }
        setControl_angle( angle ){
            if( this.m_Type == g_ObjType.play ){
                this.m_Control_angle = DataMgr.getMe().setPlaycontrol_angle( angle )
            }
        }
        initSnake(skinname:string , initLen = 0 ){

            this.m_GameTime = 0
            this.m_Control_angle = g_player_Config.g_Control_angle
            if( this.m_Type == g_ObjType.play ){
                this.m_Control_angle = DataMgr.getMe().getPlaycontrol_angle()
            }
            let T_node = UiBase.parseUiFile_static("id.json")
            this.m_headShow = T_node.getChildByName("Text_1")
            T_node.removeAllChildren()
            this.m_headShow.setString( this.m_name )
            this.m_headShow.setPosition(cc.pAdd(this.m_birth,cc.p(0,40)))
            this.addChild( this.m_headShow , 10000000)
            this.m_foodList = new Array<food_move>()
            this.m_EventEmitter = new EventEmitter();
            this.m_scale = g_Snake_Config.Body_scale

            //this.m_Speed_Up_Node = new cc.Sprite()

            this.m_skinConfig = DataMgr.getMe().getSkinConfigByName(skinname)
            this.m_WalkSpeed = g_Snake_Config.Speed

            this.m_BodyNode = cc.SpriteBatchNode.create(this.m_skinConfig["sprite_body"])
            this.m_TailNode = cc.Sprite.create(this.m_skinConfig["sprite_tail"])

            this.m_isSpeedUp = false
            this.m_isShengzhang = false
            this.m_isQiequ = false
            this.m_isPengzhang = false
            this.m_isYinshen = false
            this.m_isWudi = false
            this.m_isJianSu = false

            if(this.m_BodyNode){
                this.m_BodyNode.setPosition(cc.p(0,0))
                this.addChild(this.m_BodyNode,2)
            }
            if(this.m_TailNode){
                this.m_TailNode.setPosition(cc.p(0,0))
                this.m_TailNode.setScale(0.5)
                this.addChild(this.m_TailNode,-1)
            }
            if( initLen == 0){
                for(let j = 0; j < g_Snake_Config.Length; j++){
                    this.addSnakeLen()
                }

            }else{
                for(let j = 0; j < initLen ; j++){
                    this.addSnakeLen()
                }
            }
            this.m_score = g_scoreMgr.getScorebyLen(this.m_curLength)
            //初始粒子
            this.initlizi()
            this.initSkill()
        }
        addscore( score:number ){
            this.m_score += score
            if( g_scoreMgr.getLenbyScore(this.m_score) > this.m_curLength){
                this.addSnakeLen()
            }
        }
        setAlpha( alpha:number){
            for( let k:node = this.m_head; k!= null ; k = k.m_next){
                k.m_spr.opacity = alpha
            }
        }
        addFood( food:geziObj ){
            if(this.inFoodList( food )){
                return
            }
            else{
                let movefood = food_move.creat( this.m_head.m_spr , food )
                this.m_foodList.push( movefood )
            }
        }
        inFoodList( food:geziObj ){
            for(let j = 0; j < this.m_foodList.length; j++){
                if( food.m_id == this.m_foodList[j].m_curobj.m_id ){
                    return true
                }
            }
            return false
        }
        foodUpdate( t ){

            for(let j = 0; j < this.m_foodList.length; ){
                if( this.m_foodList[j].m_succeed  ){
                    let obj:food_move = this.m_foodList.splice( j ,1)[0]
                    this.addscore( obj .m_score)
                    mapGezi.getMe().deleteByObj( obj.m_curobj)
                    //this.addSnakeLen()
                }
                else{
                    this.m_foodList[j++].update( this.m_WalkSpeed + Math.floor(t * 100)  )
                }
            }
        }
        //换个名字换身皮肤换个坐标
        renameStart(){
            this.setVisible(true)
            let _len = g_scoreMgr.getLenbyScore( this.m_score / 2 )
            let _skinName = this.m_skinConfig.name
            this.shutdown()
            this.m_birth.x = g_map_config.border_width * 2 + Math.floor(Math.random() * (g_map_config.map_width / 2 ))
            if( _len > 5 ){
                this.initSnake(_skinName,_len )
            }else{
                this.initSnake( _skinName )
            }
        }
        reStart(){

        }
        setRunDir(dir) {
            this.m_dir = dir
        }
        getRunDir(){
            return this.m_dir
        }
        getCurWalkSpeed(){
            return this.m_WalkSpeed
        }
        shutdown() {

            this.m_EventEmitter.emit("exit");
            this.m_curLength = 0
            this.m_skinConfig = null
            this.m_foodList.length = 0
            this.m_mingci = 0
            this.m_killnum = 0
            this.m_killedName = null
            this.m_bestLen = 0
            this.m_score = 0

            this.m_isSuicide = false

            if(this.m_otherNodeList.length != 0 ){
                for( let k = 0; k < this.m_otherNodeList.length;  ){
                    this.m_otherNodeList[k].shutdown()
                    this.m_otherNodeList.splice(0,1)
                }
                this.m_otherNodeList.length = 0
                this.m_otherNodeList = null
            }
            if(this.m_otherNode){
                this.m_otherNode.removeAllChildren()
                this.removeChild(this.m_otherNode)
                this.m_otherNode = null
            }


            if( this.m_qiequList.length != 0 ){
                for( let k = 0; k < this.m_qiequList.length;k++ ){
                    this.m_qiequList[k].shutdown()
                }
                this.m_qiequList.length = 0
            }

            if(this.m_skillNode){
                this.m_skillNode.shutDown()
                //this.removeChild(this.m_skillParentNode)
                this.m_skillNode = null
            }
            if(this.m_headShow){
                this.removeChild(this.m_headShow)
                this.m_headShow = null
            }
            if(this.m_head.m_spr){
                this.removeChild(this.m_head.m_spr)
            }
            // if(this.m_Speed_Up_Node){
            //     this.removeChild(this.m_Speed_Up_Node)
            //     this.m_Speed_Up_Node = null
            // }
            if(this.m_aureole){
                this.removeChild( this.m_aureole )
                this.m_aureole = null
            }
            if(this.m_BodyNode){
                this.m_BodyNode.removeAllChildren()
                this.removeChild(this.m_BodyNode)
                this.m_BodyNode = null
            }
            if(this.m_TailNode){
                this.m_TailNode.removeAllChildren()
                this.removeChild(this.m_TailNode)
                this.m_TailNode = null
            }
            for( let n = this.m_head; n!= null;){
                let n_next = n.m_next
                n.shutdown()
                n = n_next
            }
            this.m_head = null
            this.m_tail = null
        }
        isPlay() {
            return true;
        }
        is_head(obj:node):boolean{
            if(obj === this.m_head){
                return true
            }
            return false
        }
        is_tail(obj:node):boolean{
            if(obj === this.m_tail){
                return true
            }
            return false
        }
        getMiddleBody(){
            let data = this.m_head
            for(let k = 0; k < this.m_curLength / 2; k++){
                data = data.m_next
            }
            return data
        }
        addSnakeLen(){

            let newNode:node = new node();
            newNode.m_walkSpeek = this.m_WalkSpeed
            let spr:cc.Sprite = null
            if (this.m_head == null){
                spr = cc.Sprite.create(this.m_skinConfig["sprite_head"]);
                newNode.m_spr = spr
                this.m_head = newNode;
                this.m_head.m_next = null;
                this.m_head.m_last = null;
                this.m_tail = this.m_head;
                this.m_tail.m_next = null;
                this.m_head.init(this.m_birth , null ,this ,true);
                this.addChild(newNode.m_spr,newNode.getZ())
                this.m_head.m_spr.setScale(g_snake_len_Config[0].scale)
            }
            else{
                //即将超出边界不增加长度
                // if( this.m_tail != null &&
                //     this.m_tail.getPos().x > g_map_config.border_width - g_map_config.border_width - 50 ){
                //     return
                // }

                spr = new cc.Sprite(this.m_BodyNode.getTexture());
                newNode.m_spr = spr
                this.m_tail.m_next = newNode;
                newNode.m_last = this.m_tail;
                this.m_tail = newNode;
                this.m_tail.m_next = null;
                let dir = cc.p( g_Snake_Config.interval , 0 )
                if( this.m_curLength > g_Snake_Config.Length ){
                    dir = cc.pNormalize(cc.pSub(newNode.m_last.getPos() ,  newNode.m_last.m_last.getPos()));
                }
                this.m_tail.init(null ,dir , this.m_BodyNode );
                this.m_BodyNode.addChild(spr,newNode.getZ())
                newNode.m_spr.setScale( this.m_scale )
            }

            this.m_TailNode.setScale( this.m_scale )
            this.m_TailNode.setPosition(spr.getPosition())
            this.setAngel(newNode)
            ++this.m_curLength
            for( let k = 0; k < g_snake_len_Config.length - 1; k++){
                if( this.m_curLength > g_snake_len_Config[k].len && this.m_curLength < g_snake_len_Config[k + 1].len ){
                    if(this.m_scale != g_snake_len_Config[k].scale){
                        this.m_scale = g_snake_len_Config[k].scale
                        this.scaleSnake( this.m_scale )
                    }
                }else{
                    this.m_scale = g_snake_len_Config[0].scale
                }
            }
            this.m_bestLen = this.m_curLength > this.m_bestLen ? this.m_curLength :this.m_bestLen
            this.m_bigEnergy = g_scoreMgr.getAddScoreBylen(this.m_curLength)
        }
        subSnakeLen(){
            if( this.m_curLength < 10 ){
                return false
            }
            let n = this.m_tail.m_last
            this.m_BodyNode.removeChild(this.m_tail.m_spr)
            this.m_tail.shutdown()
            this.m_tail = n
            this.m_tail.m_next = null

            this.m_score = g_scoreMgr.getScorebyLen(--this.m_curLength)

            for( let k = 0; k < g_snake_len_Config.length - 1; k++){
                if( this.m_curLength > g_snake_len_Config[k].len && this.m_curLength < g_snake_len_Config[k + 1].len ){
                    if(this.m_scale != g_snake_len_Config[k].scale){
                        this.m_scale = g_snake_len_Config[k].scale
                        this.scaleSnake( this.m_scale )
                    }
                }else{
                    this.m_scale = g_snake_len_Config[0].scale
                }

            }
        }
        scaleSnake( scale:number ){
            for(let n = this.m_head;n!=null; n = n.m_next){
                n.m_spr.setScale( scale )
            }
            this.m_head.m_spr.setScale(scale)
            this.m_TailNode.setScale(scale)
        }
        getSnakeLength():number{
            return Math.ceil(this.m_score)
            //return this.m_curLength
        }
        getHeadPos():cc.Vec2{
            return this.m_head.getPos()
        }
        getTailPos():cc.Vec2{
            return this.m_tail.getPos()
        }
        getTailByNodeId( id:number ):node{
            let n = this.m_head
            while ( n ){
                if( n.m_id == id){
                    return n
                }
                n = n.m_next
            }
            return null
        }
        fourSearch( search_depth:number ,callback:Function , point:Object  ){
            //node的id从1开始
            let unitLen:number = Math.ceil( this.m_curLength / search_depth )
            let SearchArray:Array<fourSearchNode> = new Array<fourSearchNode>()
            for( let SearchNum = 1; SearchNum <= search_depth; SearchNum ++){
                if(SearchNum == 1){
                    let _endId = unitLen
                    SearchArray.push(fourSearchNode.create( 1 , _endId , this.m_head ))
                }else{
                    let _beginId = SearchArray[SearchNum - 2].m_endId + 1
                    let _endId = unitLen * SearchNum
                    SearchArray.push(fourSearchNode.create( _beginId , _endId , this.getTailByNodeId( _beginId )))
                }
            }
            let isComplete = false
            while ( true ){
                if( isComplete || callback.call( point ,SearchArray )){
                    SearchArray.length = 0
                    break
                }
                let isOk = true
                for( let k = 0; k < SearchArray.length; k++){
                    if(!SearchArray[k].isComplete()){
                        SearchArray[k].toNext()
                        isOk = false
                    }
                }
                isComplete = isOk
            }
        }
        getDropPoint( func:Function ){
            //死亡状态时获取
            for(let n = this.m_head;n!= null; n = n.m_next){
                func(cc.pAdd(n.getPos() , cc.p(Math.random() * 40 - 20 , Math.random() * 40 - 20))  , getBigFood_Rand().type )
            }
        }
        runSkill(){
            if( this.m_Type == g_ObjType.monster ){
                this.m_skill_num = 1
            }
            else if( g_gameVersion === e_game_Version.e_money  && this.m_skill_num <= 0 && !this.m_skill_ISRelease){
                if( DataMgr.getMe().getzuansiNum() >= 20 ){
                    this.m_skill_num = 1
                    DataMgr.getMe().subZuansiNum( 20 )
                }
            }
            if(!this.m_skill_ISRelease && this.m_skill_num > 0 && !this.m_skill_isEndRelease ){
                this.m_skill_ISRelease = true
                this.m_skill_num--
                this.m_skillNode.run()
                if( this.m_skillNode.m_Type!= e_skillType.e_jiasu ){
                    this.m_WalkSpeed = g_Snake_Config.skillUpSpeed
                }
                switch (this.m_skillNode.m_Type){
                    case e_skillType.e_jiasu:
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/jiasu.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible( false )
                        this.m_isSpeedUp = true
                        break
                    case e_skillType.e_shengzhang:
                        this.m_skillNode.m_curTime = 1.1
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/shengzhang.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible( false )
                        this.m_skillNode.m_TargetLen = g_scoreMgr.getLenbyScore(this.m_skinConfig["skillpower"] * this.m_score + this.m_score )
                        this.m_isShengzhang = true
                        break
                    case e_skillType.e_touqie:
                        this.m_skillNode.m_curTime = 1.1
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/qiequ.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        //this.m_skillNode.m_spineAnimate.setScale( this.m_scale * 5 )
                        this.m_isQiequ = true
                        break
                    case e_skillType.e_dilei:
                        new role_dilei(this.m_skinConfig["kuang_icon"],null,this.getName(),this.getNode(),this.m_TailNode.getPosition())
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        this.m_isJianSu = true
                        break
                    case e_skillType.e_pengzhang:
                        cc.spriteFrameCache.addSpriteFrames("xingjietanshishe/big/teji/jiasude1.plist");
                        //this.m_skillNode.m_spineAnimate.setVisible(false)
                        this.m_skillNode.m_TargetLen = g_scoreMgr.getLenbyScore(this.m_skinConfig["skillpower"] * this.m_score + this.m_score)
                        this.m_isPengzhang = true
                        break
                    case e_skillType.e_yinshen:
                        //怪物隐身
                        if( this.m_Type == g_ObjType .monster ){
                            //this.getNode().opacity = 255
                            //this.getNode().runAction(cc.fadeIn(0.5))
                            this.setVisible( false )
                        }else{
                            //this.setAlpha( 50 )
                            this.getNode().opacity = 50
                        }
                        this.m_isYinshen = true
                        break
                    case e_skillType.e_wudi:
                        this.m_skillNode.m_spineAnimate.setScale( 0.1 )
                        this.m_skillNode.setPos(cc.p(0,0))
                        this.m_skillNode.setAngle(this.m_head.getAngle() + 180)
                        this.m_isWudi = true
                        break
                    default:
                        console.log("没有这个状态。。。")
                        break
                }
            }else{
                //console.log("技能冷却中或者已使用完毕，击杀敌人后能增加技能次数")
            }
        }
        Skill_end(){

            this.m_skillNode.stop()
            this.m_WalkSpeed = g_Snake_Config.Speed
            switch (this.m_skillNode.m_Type){
                case e_skillType.e_jiasu:
                    for( let k = 0; k < this.m_otherNodeList.length ;){
                        let n:nodeEx = this.m_otherNodeList[k]
                        if( n.m_sprite){
                            n.shutdown()
                        }
                        this.m_otherNodeList.splice(k,1)
                    }
                    this.m_isSpeedUp = false
                    this.m_WalkSpeed = g_Snake_Config.Speed
                    this.m_skill_isEndRelease = false
                    break
                case e_skillType.e_shengzhang:
                    for( let k = 0; k < this.m_otherNodeList.length ;){
                        let n:nodeEx = this.m_otherNodeList[k]
                        if( n.m_sprite){
                            n.shutdown()
                        }
                        this.m_otherNodeList.splice(k,1)
                    }
                    this.m_skillNode.m_curTarget = 0
                    this.m_isShengzhang = false
                    this.m_skill_isEndRelease = false
                    break
                case e_skillType.e_touqie:
                    for( let k = 0; k < this.m_otherNodeList.length ;){
                        let n:nodeEx = this.m_otherNodeList[k]
                        if( n.m_sprite){
                            n.shutdown()
                        }
                        this.m_otherNodeList.splice(k,1)
                    }
                    this.m_isQiequ = false
                    this.m_skill_isEndRelease = false
                    break
                case e_skillType.e_dilei:
                    this.m_isJianSu = false
                    this.m_skill_isEndRelease = false
                    break
                case e_skillType.e_pengzhang:
                    for( let k = 0; k < this.m_otherNodeList.length ;){
                        let n:nodeEx = this.m_otherNodeList[k]
                        if( n.m_sprite){
                            n.shutdown()
                        }
                        this.m_otherNodeList.splice(k,1)
                    }
                    this.m_isPengzhang = false
                    if( this.m_skillNode.m_curTarget > 0){
                        this.subSnakeLen()
                        --this.m_skillNode.m_curTarget
                    }else{
                        this.m_skill_isEndRelease = false
                    }
                    break
                case e_skillType.e_yinshen:
                    if( this.m_Type == g_ObjType .monster ){
                        //this.getNode().runAction(cc.fadeIn(0.5))
                        this.setVisible( true )
                    }else{
                        //this.getNode().opacity
                        this.setAlpha( 255 )
                    }
                    this.m_isYinshen = false
                    this.m_skill_isEndRelease = false
                    break
                case e_skillType.e_wudi:
                    this.m_isWudi = false
                    this.m_skill_isEndRelease = false
                    break
                default:
                    this.m_isQiequ = false
                    this.m_isSpeedUp = false
                    this.m_isJianSu = false
                    this.m_isPengzhang = false
                    this.m_isYinshen = false
                    this.m_isWudi = false
                    this.m_skill_isEndRelease = false
                    console.log("没有这个状态。。。")
                    break
            }
            if(this.m_skillNode.m_spineAnimate){
                this.m_skillNode.m_spineAnimate.setVisible(false)
            }
            return false
        }
        Skill_qiequ( tailNode:node ,point:baseRole ){
            if(this.m_skillNode.m_curTime > 1){
                let ani = cc.Animation.create();
                for (let k = 0;k <= 9;k++) {
                    let pngstring = k + ".png"
                    ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                }
                // 设置动画帧率
                ani.setDelayPerUnit(0.02);
                // 设置动画播放完毕后是否回到第一帧
                ani.setRestoreOriginalFrame(true);
                let animate_:cc.Animate = new cc.Animate(ani)
                let spr:cc.Sprite = cc.Sprite.create()
                spr.setScale(this.m_scale * 2)
                this.m_otherNodeList.push(new nodeEx(this.m_head,spr,this.m_otherNode,cc.repeatForever(animate_)))
                this.m_skillNode.m_curTime = 0
                let n = tailNode
                this.m_skillNode.m_TargetLen =  Math.ceil( point.m_curLength * (this.m_skinConfig["skillpower"]))

                for( let k = 0; k <  this.m_skillNode.m_TargetLen; k++){
                    this.m_qiequList.push( new RoleQiequ(n.getPos(),this.getNode() ,this.m_head))
                    point.subSnakeLen()
                    this.addscore( 3 )
                    n = n.getRearNodeByNum( -5 )
                    if( n == null){
                        return
                    }
                }
            }else{
                return
            }
        }
        Skill_update( t ){
            if(this.m_skillNode){
                this.m_skillNode.m_curTime += t
                //this.m_skillParentNode.setScale(this.m_scale)
                this.m_skill_Time -= t
                if(this.m_skill_Time < 0.3 ){
                    this.m_skill_Time = this.m_skillNode.m_Time
                    this.m_skill_ISRelease = false
                    this.m_skill_isEndRelease = true
                    this.m_skillNode.stop()
                    //this.Skill_end()
                }
                switch (this.m_skillNode.m_Type){
                    case e_skillType.e_jiasu:
                        this.m_skillMoveTime += t
                        if(this.m_skillMoveTime > 0.3){
                            this.m_skillMoveTime = 0
                            let ani = cc.Animation.create();
                            for (let k = 1;k <= 4;k++) {
                                let pngstring = "texiao_0" + k + ".png"
                                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani.setRestoreOriginalFrame(true);
                            let animate_:cc.Animate = new cc.Animate(ani)
                            let spr:cc.Sprite = cc.Sprite.create()
                            spr.setScale(this.m_scale / 2)
                            this.m_otherNodeList.push(new nodeEx(this.m_head,spr,this.m_otherNode,cc.repeatForever(animate_)))
                        }

                        for( let k = 0; k < this.m_otherNodeList.length ; k++){
                            if(!this.m_otherNodeList[k].m_isComplete){
                                this.m_otherNodeList[k].update( t )
                            }
                        }
                        this.m_WalkSpeed = g_Snake_Config.accSpeed
                        break
                    case e_skillType.e_shengzhang:
                        this.m_skillMoveTime += t
                        if(this.m_skillMoveTime > 0.3){
                            this.m_skillMoveTime = 0
                            let ani_shengzhang = cc.Animation.create();
                            for (let k = 0;k <= 5;k++) {
                                let pngstring = "h_n_fire" + k + ".png"
                                ani_shengzhang.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani_shengzhang.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani_shengzhang.setRestoreOriginalFrame(true);
                            let animate_shengzhang:cc.Animate = new cc.Animate(ani_shengzhang)
                            let spr_shengzhang:cc.Sprite = cc.Sprite.create()
                            spr_shengzhang.setScale(this.m_scale)
                            this.m_otherNodeList.push(new nodeEx(this.m_head,spr_shengzhang,this.m_otherNode,cc.repeatForever(animate_shengzhang)))
                        }
                        if( this.m_skillNode.m_curTime > 1){
                            this.m_skillNode.m_curTime = 0
                            let NodeP = this.m_TailNode.getPosition()
                            if( NodeP.x >= g_map_config.border_width * 1.5 && NodeP.x < g_map_config.map_width - g_map_config.border_width * 1.5
                                && NodeP.y > g_map_config.border_height * 1.5 && NodeP.y < g_map_config.map_height - g_map_config.border_height * 1.5){
                                for( let k = 0; k < Math.max( 1 , Math.ceil(this.m_skillNode.m_TargetLen / 5)); k++){
                                    this.addscore(g_Snake_Config.big_energy)
                                    //this.m_skillNode.m_curTarget++
                                }
                            }
                        }
                        for( let k = 0; k < this.m_otherNodeList.length ; k++){
                            if(!this.m_otherNodeList[k].m_isComplete){
                                this.m_otherNodeList[k].update( t )
                            }
                        }
                        break
                    case e_skillType.e_touqie:
                        for( let k = 0; k < this.m_otherNodeList.length ; k++){
                            if(!this.m_otherNodeList[k].m_isComplete){
                                this.m_otherNodeList[k].update( t , true )
                                // if(this.m_otherNodeList[k].m_sprite){
                                //     //this.m_otherNodeList[k].m_sprite.setScale( this.m_scale )
                                // }
                                //this.m_otherNodeList[k].m_sprite.setRotation( this.m_otherNodeList[k].m_sprite.getRotation() + 10 )
                            }
                        }
                        // this.m_skillNode.setPos(this.m_head.getPos())
                        // this.m_skillNode.setAngle( this.m_skillNode.m_angle + 10 )
                        break
                    case e_skillType.e_dilei:
                        if(this.m_skillNode.m_curTime > 4 ){
                            this.m_skillNode.m_curTime = 0
                            //if( this.m_TailNode!= null )
                            new role_dilei(this.m_skinConfig["kuang_icon"],null,this.getName(),this.getNode(),this.m_TailNode.getPosition())
                        }
                        // this.m_skillNode.setPos(this.m_head.getPos())
                        // this.m_skillNode.setAngle(this.m_head.getAngle() + 180)
                        break
                    case e_skillType.e_pengzhang:
                        this.m_skillMoveTime += t
                        if(this.m_skillMoveTime > 0.3){
                            this.m_skillMoveTime = 0
                            let ani = cc.Animation.create();
                            for (let k = 1;k <= 6;k++) {
                                let pngstring = "jiansude_0" + k + ".png"
                                ani.addSpriteFrame(cc.spriteFrameCache.getSpriteFrame(pngstring));
                            }
                            // 设置动画帧率
                            ani.setDelayPerUnit(0.02);
                            // 设置动画播放完毕后是否回到第一帧
                            ani.setRestoreOriginalFrame(true);
                            let animate_:cc.Animate = new cc.Animate(ani)
                            let spr:cc.Sprite = cc.Sprite.create()
                            spr.setScale(this.m_scale)
                            this.m_otherNodeList.push(new nodeEx(this.m_head,spr,this.m_otherNode,cc.repeatForever(animate_)))
                        }
                        for( let k = 0; k < this.m_otherNodeList.length ; k++){
                            if(!this.m_otherNodeList[k].m_isComplete){
                                this.m_otherNodeList[k].update( t )
                            }
                        }
                        if( this.m_curLength < this.m_skillNode.m_TargetLen ){
                            let NodeP = this.m_TailNode.getPosition()
                            if( NodeP.x >= g_map_config.border_width * 1.5 && NodeP.x < g_map_config.map_width - g_map_config.border_width * 1.5
                                && NodeP.y > g_map_config.border_height * 1.5 && NodeP.y < g_map_config.map_height - g_map_config.border_height * 1.5){
                                //this.addSnakeLen()
                                this.addscore(this.m_bigEnergy)
                                this.m_skillNode.m_curTarget++
                            }
                        }
                        break
                    case e_skillType.e_yinshen:

                        break
                    case e_skillType.e_wudi:
                        if( this.m_Type == g_ObjType.monster ){
                            if(roleMgr.getMe().getControlPlayer().getCurStateType() != g_AiType.g_AiType_wudi
                                && ! roleMgr.getMe().getControlPlayer().m_isYinshen && this.m_skill_Time > 2){
                                if(cc.pDistance(roleMgr.getMe().getControlPlayer().m_head.getPos(),
                                        this.m_head.getPos()) < 500){
                                    let Angle = cc.pToAngle( this.m_dir )/ Math.PI * 180
                                    let newDir:cc.Vec2 = cc.pNormalize(cc.pSub( roleMgr.getMe().getControlPlayer().m_head.getPos(),
                                        this.m_head.getPos()))
                                    let nangle = cc.pToAngle( newDir )/ Math.PI * 180
                                    if(nangle > Angle){
                                        this.m_dir = cc.pForAngle( (Angle +  this.m_Control_angle / 2 ) * Math.PI / 180)
                                    }else{
                                        this.m_dir = cc.pForAngle( (Angle -  this.m_Control_angle / 2 ) * Math.PI / 180)
                                    }
                                }
                            }
                        }
                        this.m_skillNode.m_spineAnimate.setScale( this.m_scale * 5.125 )
                        this.m_skillNode.setPos(this.m_head.getPos())
                        this.m_skillNode.setAngle(this.m_head.getAngle() + 180)
                        break
                    default:
                        console.log("没有这个状态。。。")
                        break
                }
            }
        }
        collideWall(){
            let radius = this.m_head.getradius()
            if(this.getHeadPos().x - radius <= g_map_config.border_width  || this.getHeadPos().x + radius > g_map_config.map_width - g_map_config.border_width
                ||this.getHeadPos().y - radius <= g_map_config.border_height || this.getHeadPos().y + radius >= g_map_config.map_height - g_map_config.border_height ){
                this.m_killedName = null
                return true
            }
            return false
        }
        loop( t ) {

            this.m_GameTime += t
            this.m_dir = cc.pNormalize(  this.m_dir )
            if(this.m_foodList.length != 0){
                this.foodUpdate( t )
            }
            //技能 释放状态
            if(this.m_skill_ISRelease){
                this.Skill_update( t )
            }
            //技能未回收完毕的情况下
            if( this.m_skill_isEndRelease ){
                this.Skill_end()
            }

            if(  !this.m_isWudi
                && this.getCurStateType() != g_AiType.g_AiType_wudi
                && role_dileiMgr.getMe().getcurSize() != 0 ){
                let colideNode:role_dilei  = role_dileiMgr.getMe().colide( this.m_head )
                if( colideNode != null){
                    if(colideNode.m_Relesename != this.getName()){
                        this.m_killedName = colideNode.m_Relesename
                        ui_fight.getMe().updateShowKill(colideNode.m_Relesename,colideNode.m_roleHeadimgPath,this.getName(),this.m_skinConfig["kuang_icon"])
                        this.getDropPoint(mapGezi.getMe().addGeziObj.bind(mapGezi.getMe()))
                        this.changeState_Ex(g_AiType.g_AiType_dead)
                        colideNode.setBoom()
                        return
                    }
                }
            }
            if( this.m_qiequList.length != 0 ){
                for( let k = 0; k < this.m_qiequList.length; ){
                    if( this.m_qiequList[k].m_isComplete ){
                        this.m_qiequList[k].shutdown()
                        this.m_qiequList.splice( k, 1 )
                    }else{
                        this.m_qiequList[k].update( t,this.m_WalkSpeed )
                        k++
                    }
                }
            }

        };
        setAngel(obj:node){
            if (this.is_head(obj)) {
                let angel = 90 + cc.pToAngle( this.m_dir ) / Math.PI * 180
                obj.setAngle( -angel )
            }
            else{
                let dir:cc.Vec2 = (cc.Vec2.sub(obj.getPos() , obj.m_last.getPos())).normalize();
                let angel = 90 - cc.pToAngle(dir)/ Math.PI * 180
                if(this.is_tail(obj)) {
                    this.m_TailNode.setRotation( angel )
                }
                obj.setAngle( angel )
            }
        }
        isdead() {
            if (this.getCurStateType() == g_AiType.g_AiType_dead) {
                return true;
            }
            return false
        }
        getDis(pos) {
            //return cc.pDistance(this.getPosition(), pos);
            let ret = cc.pSub(this.getPosition(), pos);
            return Math.abs(ret.x);
        }
        changeState(key, data=null) {
            this.m_StateControl.changeState_Ex(key,data)
        }
        changeState_Ex(type) {
        }
        getCurStateType() {
            return this.m_StateControl.getCurStateType();
        }
    }
}