var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var monster = (function (_super) {
        __extends(monster, _super);
        function monster() {
            _super.call(this);
            this.m_propertyInfo = null;
            this.m_birthwave = null;
            this.m_Type = game.g_ObjType.monster;
            this.m_StateControl = new game.monsterStateControl(this);
        }
        // setStand( isStand:boolean ){
        //     this.m_stand = isStand
        // }
        // getStand():boolean{
        //     return this.m_stand
        // }
        monster.prototype.init = function (pifuName) {
            //this.loadres(pifuName);
            this.initSnake(pifuName);
            this.initState();
        };
        monster.prototype.initSnake = function (skinname, len) {
            if (len === void 0) { len = 0; }
            this.m_dir.x = -Math.abs(Math.random() * 1);
            this.m_dir.y = Math.random() * 1 - 0.5;
            this.m_birth.x = Math.ceil(Math.random() * (game.g_map_config.map_width - game.g_map_config.border_width * 4) + game.g_map_config.border_width * 2);
            this.m_birth.y = Math.ceil(Math.random() * (game.g_map_config.map_height - game.g_map_config.border_height * 4) + game.g_map_config.border_height * 2);
            _super.prototype.initSnake.call(this, skinname, len);
            //this.m_SpeedUp_time = 6
        };
        monster.prototype.initState = function () {
            this.m_StateControl.initState();
        };
        monster.prototype.getState = function (type) {
            return this.m_StateControl.getState(type);
        };
        //强制切换状态
        monster.prototype.changeState_Ex = function (key, data) {
            if (data === void 0) { data = null; }
            if (this.getCurStateType() == game.g_AiType.g_AiType_taoyi && key == game.g_AiType.g_AiType_taoyi
                || this.getCurStateType() == game.g_AiType.g_AiType_elude && key == game.g_AiType.g_AiType_elude) {
                return false;
            }
            return this.m_StateControl.changeState_Ex(key, data);
        };
        monster.prototype.changeState = function (key, in_data) {
            if (in_data === void 0) { in_data = null; }
            // console.log(key);
            return this.m_StateControl.changeState(key, in_data);
        };
        monster.prototype.monster_auto = function (data) {
            var randAdd = Math.random() * 100;
            if (randAdd < 5) {
                data.addscore(Math.floor(Math.random() * 2));
            }
        };
        monster.prototype.toPlayerLen = function (p) {
            if (game.roleMgr.getMe().getControlPlayer()) {
                return cc.pDistance(p, game.roleMgr.getMe().getControlPlayer().getHeadPos());
            }
            return 0;
        };
        monster.prototype.loop = function (t) {
            //return
            this.m_StateControl.loop(t);
            if (this.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return;
            }
            //超出屏幕外(最大长度)的不执行逻辑，随机增加长度
            if (this.toPlayerLen(this.getHeadPos()) > cc.winSize.width * 0.75 &&
                this.toPlayerLen(this.getTailPos()) > cc.winSize.width * 0.75) {
                this.monster_auto(this);
                this.m_isAuto = true;
                return;
            }
            else {
                if (this.m_isSetAngle) {
                    this.m_isSetAngle = false;
                }
                else {
                    this.m_isSetAngle = true;
                }
                this.m_isAuto = false;
                //边界
                var myHeadPos = this.getHeadPos();
                if (myHeadPos.x <= game.g_map_config.border_width * 2 || myHeadPos.x > game.g_map_config.map_width - game.g_map_config.border_width * 2
                    || myHeadPos.y <= game.g_map_config.border_height * 2 || myHeadPos.y >= game.g_map_config.map_height - game.g_map_config.border_height * 2) {
                    //如果当前自杀状态打开，直接撞死
                    if (!this.m_isSuicide) {
                        this.changeState_Ex(game.g_AiType.g_AiType_taoyi);
                    }
                }
                var _sPeed = this.m_WalkSpeed + Math.floor(t * 100);
                for (var n = this.m_head; n != null; n = n.m_next) {
                    if (this.is_head(n)) {
                        //撞墙检测
                        if (this.collideWall()) {
                            this.changeState_Ex(game.g_AiType.g_AiType_dead);
                            return;
                        }
                        var pos = n.getPos();
                        n.setPos(cc.pAdd(pos, cc.pMult(this.m_dir, _sPeed)));
                        if (n.m_next != null) {
                            n.m_next.push_Front_Ex(pos, _sPeed, this.m_dir);
                        }
                        this.m_headShow.setPosition(cc.pAdd(pos, cc.p(0, 40)));
                        game.mapGezi.getMe().colide(this);
                    }
                    else {
                        n.setPos(n.popPos_Ex(_sPeed));
                        if (n.m_next != null) {
                            if (!n.m_spr.isVisible()) {
                                n.m_spr.setVisible(true);
                            }
                        }
                        if (this.is_tail(n)) {
                            n.m_spr.setVisible(false);
                            this.m_TailNode.setPosition(n.getPos());
                        }
                    }
                    if (this.m_isSetAngle) {
                        this.setAngel(n);
                    }
                }
            }
            _super.prototype.loop.call(this, t);
            this.update(t);
        };
        monster.prototype.update = function (dt) {
            _super.prototype.update.call(this, dt);
        };
        monster.prototype.getCurStateType = function () {
            return this.m_StateControl.getCurStateType();
        };
        //m_stand:boolean = false //静止状态，距离 玩家超出一定距离不执行逻辑，长度随机增加，
        monster.create = function () {
            return new monster();
        };
        return monster;
    }(game.baseRole));
    game.monster = monster;
})(game || (game = {}));
//# sourceMappingURL=monster.js.map