var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var game;
(function (game) {
    var player = (function (_super) {
        __extends(player, _super);
        function player() {
            _super.call(this);
            this.m_best_len = 0;
            this.m_best_kill = 0;
            this.m_propertyInfo = null;
            this.m_Type = game.g_ObjType.play;
            this.m_StateControl = new game.playStateControl(this);
        }
        player.prototype.init = function (pifuName, initLen) {
            if (initLen === void 0) { initLen = 0; }
            this.m_best_len = game.DataMgr.getMe().getPlayerBestLen(game.DataMgr.getMe().getCurfightType());
            this.m_best_kill = game.DataMgr.getMe().getPlayerBestKill(game.DataMgr.getMe().getCurfightType());
            this.m_birth = cc.p(game.g_map_config.map_width / 2, game.g_map_config.map_height / 2);
            game.cameraMgr.getMe().reset(this.m_birth);
            this.m_dir = cc.p(1, Math.random() * 0.2 - 0.4);
            this.initSnake(pifuName, initLen);
            this.initState();
        };
        player.prototype.initState = function () {
            this.m_StateControl.initState();
        };
        player.prototype.getState = function (type) {
            return this.m_StateControl.getState(type);
        };
        player.prototype.shutdown = function () {
            _super.prototype.shutdown.call(this);
        };
        player.prototype.reStart = function () {
            var reLen = game.g_scoreMgr.getLenbyScore(this.m_score / 2);
            this.shutdown();
            if (reLen > 5) {
                this.init(game.DataMgr.getMe().getPlayDoc().curpifu, reLen);
            }
            else {
                this.init(game.DataMgr.getMe().getPlayDoc().curpifu);
            }
            game.cameraMgr.getMe().reset(this.m_birth);
            this.setVisible(true);
        };
        //强制切换状态
        player.prototype.changeState_Ex = function (key, data) {
            if (data === void 0) { data = null; }
            return this.m_StateControl.changeState_Ex(key, data);
        };
        player.prototype.changeState = function (key, in_data) {
            if (in_data === void 0) { in_data = null; }
            // console.log(key);
            return this.m_StateControl.changeState(key, in_data);
        };
        player.prototype.loop = function (t) {
            this.m_StateControl.loop(t);
            if (this.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return;
            }
            if (this.m_isSetAngle) {
                this.m_isSetAngle = false;
            }
            else {
                this.m_isSetAngle = true;
            }
            var _sPeed = this.m_WalkSpeed + Math.floor(t * 100);
            for (var n = this.m_head; n != null; n = n.m_next) {
                if (this.is_head(n)) {
                    //撞墙检测
                    if (this.collideWall()) {
                        this.changeState_Ex(game.g_AiType.g_AiType_dead);
                        return;
                    }
                    var p = n.getPos();
                    n.setPos(cc.pAdd(n.getPos(), cc.pMult(this.m_dir, _sPeed)));
                    if (n.m_next != null) {
                        n.m_next.push_Front_Ex(p, _sPeed, this.m_dir);
                    }
                    this.m_headShow.setPosition(cc.pAdd(n.getPos(), cc.p(0, 40)));
                    game.mapGezi.getMe().colide(this);
                }
                else {
                    n.setPos(n.popPos_Ex(_sPeed));
                    if (n.m_next != null) {
                        if (!n.m_spr.isVisible()) {
                            n.m_spr.setVisible(true);
                        }
                    }
                    if (this.is_tail(n)) {
                        n.m_spr.setVisible(false);
                        this.m_TailNode.setPosition(n.getPos());
                    }
                }
                if (this.m_isYinshen) {
                    n.m_spr.opacity = 50;
                }
                if (this.m_isSetAngle) {
                    this.setAngel(n);
                }
            }
            _super.prototype.loop.call(this, t);
            this.update(t);
        };
        player.prototype.update = function (dt) {
            _super.prototype.update.call(this, dt);
        };
        player.prototype.fuhuo = function () {
            this.changeState_Ex(game.g_AiType.g_AiType_wudi);
        };
        player.create = function () {
            return new player();
        };
        return player;
    }(game.baseRole));
    game.player = player;
})(game || (game = {}));
//# sourceMappingURL=Player.js.map