var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
// 角色管理类
var game;
(function (game) {
    var roleMgr = (function (_super) {
        __extends(roleMgr, _super);
        function roleMgr() {
            _super.call(this);
            this.m_curRole = null;
            this.m_monster_map = null;
            this.m_player_map = null;
            this.m_AllRole_map = null;
            this.m_player_map_Alive = null;
            this.m_monster_map_Alive = null;
            this.m_player_map_dead = null;
            this.m_monster_map_dead = null;
            this.m_sceneinfo = null;
            this.m_pause = false;
            this.m_killTime = 20; //多久查找一次长度超过八百的蛇
            this.m_CanColide = false;
            this.m_monster_map = new game.MapGame();
            this.m_player_map = new game.MapGame();
            this.m_AllRole_map = new game.MapGame();
            this.m_player_map_Alive = new game.MapGame();
            this.m_monster_map_Alive = new game.MapGame();
            this.m_player_map_dead = new game.MapGame();
            this.m_monster_map_dead = new game.MapGame();
        }
        //当前被控制的角色
        roleMgr.prototype.getControlPlayer = function () {
            return this.m_curRole;
        };
        /////////////////////调试阻挡模块 结束  ////////////////////
        roleMgr.prototype.initroleMgr = function (sceneinfo) {
            if (this.m_curRole) {
                return;
            }
            this.m_sceneinfo = sceneinfo;
            //let role = this.createPlayer();
        };
        roleMgr.prototype.createEnerty = function () {
            game.mapGezi.getMe().init(this);
            //energy_Mgr.getMe().init(this)
        };
        //create monster
        roleMgr.prototype.createMonster = function (name, skinName) {
            if (skinName === void 0) { skinName = null; }
            var l_monster = game.monster.create();
            //l_monster.initSnake(g_skinMgr.getMe().round_skin())
            l_monster.setName(name);
            if (skinName == null) {
                l_monster.init(game.g_skinMgr.getMe().round_skin());
            }
            else {
                l_monster.init(skinName);
            }
            this.addChild(l_monster.getNode(), 0);
            this.m_monster_map.put(l_monster.__instanceId, l_monster);
            this.m_AllRole_map.put(l_monster.__instanceId, l_monster);
            return l_monster;
        };
        roleMgr.prototype.removeMonster = function (l_monster) {
            var monstername = l_monster.getName();
            if (this.m_monster_map_dead.hasData(monstername)) {
                var deadnum = this.m_monster_map_dead.getDataByKey(monstername);
                this.m_monster_map_dead.put(monstername, deadnum + 1);
            }
            else {
                this.m_monster_map_dead.put(monstername, 1);
            }
            this.m_monster_map.remove(l_monster.__instanceId);
            this.m_AllRole_map.remove(l_monster.__instanceId);
            l_monster.shutdown();
            this.removeChild(l_monster.getNode());
        };
        // 当前玩家
        roleMgr.prototype.createPlayer = function () {
            //this.createEnerty()
            var l_player = game.player.create();
            this.m_curRole = l_player;
            l_player.setName(game.DataMgr.getMe().getPlayerName());
            l_player.init(game.DataMgr.getMe().getPlayDoc().curpifu, game.g_Snake_Config.playerTestLen);
            this.addChild(l_player.getNode(), 1000);
            this.m_player_map.put(l_player.__instanceId, l_player);
            this.m_AllRole_map.put(l_player.__instanceId, l_player);
            this.m_player_map_Alive.put(l_player.__instanceId, l_player);
            return l_player;
        };
        roleMgr.prototype.shutdown = function () {
            game.role_dileiMgr.getMe().shutdown();
            for (var i = 0; i < this.m_AllRole_map.size(); ++i) {
                var data = this.m_AllRole_map.getData(i);
                data.shutdown();
                this.removeChild(data.getNode());
            }
            this.m_player_map_Alive.clear();
            this.m_player_map.clear();
            this.m_monster_map.clear();
            this.m_AllRole_map.clear();
            this.m_curRole = null;
            game.mapGezi.getMe().shutDown();
        };
        roleMgr.prototype.resetMonsterDeadNum = function () {
            this.m_monster_map_dead.clear();
        };
        roleMgr.prototype.getMonsterDeadNumByName = function (name) {
            var monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (var i = 0; i < this.m_monster_map_dead.getSize(); ++i) {
                    var obj = this.m_monster_map_dead.getKey(i);
                    if (obj == name) {
                        monsterDeadNum = this.m_monster_map_dead.getData(i);
                        break;
                    }
                }
            }
            return monsterDeadNum;
        };
        roleMgr.prototype.getMonsterDeadNum = function () {
            var monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (var i = 0; i < this.m_monster_map_dead.getSize(); ++i) {
                    var num = this.m_monster_map_dead.getData(i);
                    monsterDeadNum += num;
                }
            }
            return monsterDeadNum;
        };
        roleMgr.prototype.getMonsterAliveByWave = function (birthWave) {
            var count = 0;
            var l_MonsterAlive = this.getMonsterAlive();
            for (var i = 0; i < l_MonsterAlive.getSize(); ++i) {
                var monster_1 = l_MonsterAlive.getData(i);
                if (monster_1.m_birthwave == birthWave)
                    count++;
            }
            return count;
        };
        roleMgr.prototype.getRoleById = function (id) {
            var pRole = null;
            if (this.m_AllRole_map.hasData(id)) {
                pRole = this.m_AllRole_map.getDataByKey(id);
                if (pRole.isdead()) {
                    return null;
                }
            }
            return pRole;
        };
        //获取没有死掉的怪物
        roleMgr.prototype.getMonsterAlive = function () {
            //  this.m_monster_map_Alive.clear();
            //   for (let i = 0; i < this.m_monster_map.getSize(); ++i) {
            //       let obj = this.m_monster_map.getData(i);
            //       if (!obj.isdead()) {
            //           this.m_monster_map_Alive.put(obj.__instanceId, obj);
            //       }
            //   }
            return this.m_monster_map_Alive; //活着的怪物
        };
        //获取长度超过八百的怪物
        roleMgr.prototype.getExceedingMonster = function () {
            var ExceedingMonsterList = new Array();
            this.m_monster_map.each(function (key, obj) {
                if (obj.getSnakeLength() >= 1600) {
                    ExceedingMonsterList.push(obj);
                }
            }, this, null);
            return ExceedingMonsterList;
        };
        //暂停动画
        roleMgr.prototype.zanting = function (falg) {
            // this.m_AllRole_map.each(function (k, data) {
            //     data.zanting(falg);
            // }, this);
        };
        roleMgr.prototype.min_2Ptolen = function (obj1, obj2) {
            var obj1_headP = obj1.getHeadPos();
            var obj1_tailP = obj1.getTailPos();
            var obj2_headP = obj2.getHeadPos();
            var obj2_tailP = obj2.getTailPos();
            var obj1len = obj1.m_curLength * (obj1.m_head.getradius());
            var obj2len = obj2.m_curLength * (obj2.m_head.getradius());
            var length1 = game.mathEx.getDistance(obj1_headP, obj2_headP);
            var length2 = game.mathEx.getDistance(obj1_headP, obj2_tailP);
            var length3 = game.mathEx.getDistance(obj1_tailP, obj2_headP);
            var length4 = game.mathEx.getDistance(obj1_headP, obj2_tailP);
            var length = Math.min(length1, length2, length3, length4);
            if (length < obj1len + obj2len) {
                return true;
            }
            return false;
        };
        roleMgr.prototype.toPlayerLen = function (p) {
            if (this.getControlPlayer()) {
                return game.mathEx.getDistance(p, this.getControlPlayer().getHeadPos());
            }
            return 0;
        };
        //所有不参与碰撞检测的条件往这里面扔
        roleMgr.prototype.colide_exclude = function (obj, data2) {
            if (data2 === void 0) { data2 = null; }
            if (obj.getCurStateType() == game.g_AiType.g_AiType_dead) {
                return false;
            }
            if (obj.getCurStateType() == game.g_AiType.g_AiType_wudi) {
                return false;
            }
            if (obj.m_isAuto == true) {
                return false;
            }
            // if( obj.m_isWudi ){
            //     return false
            // }
            if (data2) {
                if (data2.__instanceId == obj.__instanceId) {
                    return false;
                }
                if (!this.min_2Ptolen(data2, obj)) {
                    return false;
                }
                // if( data2.m_isWudi ){
                //     return false
                // }
                if (data2.getCurStateType() == game.g_AiType.g_AiType_dead) {
                    return false;
                }
                if (data2.getCurStateType() == game.g_AiType.g_AiType_wudi) {
                    return false;
                }
                if (data2.m_isAuto == true) {
                    return false;
                }
            }
            return true;
        };
        roleMgr.prototype.colide = function (obj) {
            var _this = this;
            var isColide = false;
            var myHeadPos = obj.getHeadPos(); //需要检测对象的头坐标
            var myradius = obj.m_head.getradius(); //对象的碰撞半径
            this.m_AllRole_map.each(function (key, data) {
                if (!_this.colide_exclude(obj, data) || isColide || obj.m_isWudi) {
                    return false;
                }
                //四分搜索
                var otherradius = data.m_head.getradius();
                var searchDepth = data.m_curLength > 20 ? data.m_curLength / 10 : 1;
                data.fourSearch(searchDepth, function (nodeList) {
                    var minDistance = 10000;
                    var minNode = null;
                    for (var k = 0; k < nodeList.length; k++) {
                        //console.log(nodeList.length)
                        if (nodeList[k].m_Point != null) {
                            var tomyLen = game.mathEx.getDistance(nodeList[k].m_Point.getPos(), myHeadPos);
                            if (tomyLen > 200) {
                                nodeList[k].setComplete();
                                continue;
                            }
                            if (minDistance > tomyLen) {
                                minDistance = tomyLen;
                                minNode = nodeList[k].m_Point;
                            }
                            //即将碰撞 对方隐身不进行障碍 检测
                            if (!obj.m_isSuicide && minDistance < 120 && obj.m_Type == game.g_ObjType.monster && !data.m_isYinshen && obj.getCurStateType() != game.g_AiType.g_AiType_elude) {
                                //只检测与头的前进方向一致的坐标
                                var t_pos = cc.pAdd(myHeadPos, cc.pMult(obj.m_dir, 10));
                                var dis = game.mathEx.getDistance(t_pos, nodeList[k].m_Point.getPos());
                                if (dis < minDistance) {
                                    if (Math.random() * 100 < game.g_AI_Config.monster_elude_Prob) {
                                        obj.changeState_Ex(game.g_AiType.g_AiType_elude);
                                    }
                                    else {
                                        obj.changeState_Ex(game.g_AiType.g_AiType_stand);
                                    }
                                }
                            }
                        }
                    }
                    //当前有技能正在释放
                    if (obj.m_skill_ISRelease) {
                        //如果当前状态为窃取对长度的状态
                        if (obj.m_skillNode.m_Type == game.e_skillType.e_touqie) {
                            if (minDistance < game.g_skill_config.touqu_radius) {
                                obj.Skill_qiequ(data.m_tail, data);
                            }
                        }
                    }
                    //发生碰撞
                    if (minDistance < myradius + otherradius) {
                        data.m_killnum++;
                        data.m_skill_num++;
                        obj.m_killedName = data.getName();
                        //
                        game.ui_fight.getMe().updateShowKill(data.getName(), data.m_skinConfig["kuang_icon"], obj.getName(), obj.m_skinConfig["kuang_icon"]);
                        if (data.m_Type == game.g_ObjType.monster) {
                            data.changeState_Ex(game.g_AiType.g_AiType_findFood);
                        }
                        if (data.m_skillNode.m_Type == game.e_skillType.e_yinshen && data.m_skill_ISRelease) {
                            data.m_skill_ISRelease = false;
                            data.m_skill_Time = data.m_skillNode.m_Time;
                            data.m_skill_isEndRelease = true;
                            data.m_skillNode.stop();
                        }
                        if (data.is_head(minNode) && !data.m_isWudi) {
                            data.m_killedName = obj.getName();
                            obj.m_killnum++;
                            data.getDropPoint(game.mapGezi.getMe().addGeziObj.bind(game.mapGezi.getMe()));
                            data.changeState_Ex(game.g_AiType.g_AiType_dead);
                        }
                        isColide = true;
                        return true;
                    }
                    return false;
                }, data);
                //a10.end("碰撞检测：")
            }, this, null);
            return isColide;
        };
        roleMgr.prototype.update = function (t) {
            var _this = this;
            if (this.m_pause) {
                return;
            }
            this.m_killTime -= t;
            if (this.m_killTime <= 0) {
                this.m_killTime = 20;
                var exceedingMonster = this.getExceedingMonster();
                for (var k = 0; k < exceedingMonster.length; k++) {
                    if (k != 0) {
                        var OBJ = exceedingMonster[k];
                        OBJ.m_isSuicide = true;
                        console.log(OBJ.getName() + "自杀模式已开启..");
                    }
                }
            }
            //地雷
            if (game.role_dileiMgr.getMe().getcurSize() != 0) {
                game.role_dileiMgr.getMe().update(t);
            }
            //这里是控制碰撞间隔
            this.m_AllRole_map.each(function (key, data) {
                //let a = proforFunc.create();
                data.loop(t);
                //a.end("逻辑循环")
                //if( this.m_CanColide == true ){
                //let b = proforFunc.create();
                if (_this.colide(data)) {
                    if (data.m_killedName) {
                        //不是被墙杀死才刷逗子
                        data.getDropPoint(game.mapGezi.getMe().addGeziObj.bind(game.mapGezi.getMe()));
                    }
                    data.m_StateControl.changeState_Ex(game.g_AiType.g_AiType_dead);
                }
                //}
                //b.end("碰撞检测")
            }, this, null);
        };
        roleMgr.getMe = function () {
            if (game.sceneMgr.getMe().m_curScene == null) {
                return null;
            }
            return game.sceneMgr.getMe().m_curScene.getRoleMgr();
        };
        roleMgr.create = function () {
            return new roleMgr();
        };
        return roleMgr;
    }(game.xjNode));
    game.roleMgr = roleMgr;
})(game || (game = {}));
//# sourceMappingURL=roleMgr.js.map