// 角色管理类
module game {

    export class roleMgr extends xjNode {
        m_curRole: player = null;
        m_monster_map: MapGame = null;
        m_player_map: MapGame = null;
        m_AllRole_map: MapGame = null;
        m_player_map_Alive: MapGame = null;
        m_monster_map_Alive: MapGame = null;
        m_player_map_dead: any = null;
        m_monster_map_dead: any = null;
        m_sceneinfo: any = null;
        m_pause:boolean = false
        m_killTime:number = 20 //多久查找一次长度超过八百的蛇
        m_CanColide:boolean = false
        static getMe = function (): roleMgr {
            if (sceneMgr.getMe().m_curScene == null) {
                return null;
            }
            return sceneMgr.getMe().m_curScene.getRoleMgr();
        };
        static create = function (): roleMgr {
            return new roleMgr();
        };

        constructor() {
            super();
            this.m_monster_map = new MapGame();
            this.m_player_map = new MapGame();
            this.m_AllRole_map = new MapGame();
            this.m_player_map_Alive = new MapGame();
            this.m_monster_map_Alive = new MapGame();
            this.m_player_map_dead = new MapGame();
            this.m_monster_map_dead = new MapGame();
        }

        //当前被控制的角色
        getControlPlayer() {
            return this.m_curRole;
        }

        /////////////////////调试阻挡模块 结束  ////////////////////
        initroleMgr(sceneinfo) {
            if (this.m_curRole) {
                return;
            }
            this.m_sceneinfo = sceneinfo;
            //let role = this.createPlayer();

        }
        createEnerty(){
            mapGezi.getMe().init(this)
            //energy_Mgr.getMe().init(this)
        }
        //create monster
        createMonster( name:string , skinName:string = null ) {
            let l_monster = monster.create();


            //l_monster.initSnake(g_skinMgr.getMe().round_skin())
            l_monster.setName( name )
            if(skinName == null){
                l_monster.init(g_skinMgr.getMe().round_skin());
            }else{
                l_monster.init( skinName );
            }
            this.addChild(l_monster.getNode(), 0);
            this.m_monster_map.put(l_monster.__instanceId, l_monster);
            this.m_AllRole_map.put(l_monster.__instanceId, l_monster);
            return l_monster;
        }

        removeMonster(l_monster) {
            let monstername = l_monster.getName();
            if (this.m_monster_map_dead.hasData(monstername)) {
                let deadnum = this.m_monster_map_dead.getDataByKey(monstername);
                this.m_monster_map_dead.put(monstername, deadnum + 1);
            }
            else {
                this.m_monster_map_dead.put(monstername, 1);
            }
            this.m_monster_map.remove(l_monster.__instanceId);
            this.m_AllRole_map.remove(l_monster.__instanceId);
            l_monster.shutdown();
            this.removeChild(l_monster.getNode());
        }

        // 当前玩家
        createPlayer() {
            //this.createEnerty()
            let l_player = player.create();
            this.m_curRole = l_player;
            l_player.setName(DataMgr.getMe().getPlayerName())
            l_player.init(DataMgr.getMe().getPlayDoc().curpifu , g_Snake_Config.playerTestLen );
            this.addChild(l_player.getNode(), 1000);
            this.m_player_map.put(l_player.__instanceId, l_player);
            this.m_AllRole_map.put(l_player.__instanceId, l_player);
            this.m_player_map_Alive.put(l_player.__instanceId, l_player);
            return l_player;
        }

        shutdown() {
            role_dileiMgr.getMe().shutdown()
            for (let i = 0; i < this.m_AllRole_map.size(); ++i) {
                let data:baseRole = this.m_AllRole_map.getData(i);
                data.shutdown();
                this.removeChild(data.getNode())
            }
            this.m_player_map_Alive.clear();
            this.m_player_map.clear()
            this.m_monster_map.clear()
            this.m_AllRole_map.clear()
            this.m_curRole = null

            mapGezi.getMe().shutDown()

        }

        resetMonsterDeadNum() {
            this.m_monster_map_dead.clear();
        }

        getMonsterDeadNumByName(name) {
            let monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (let i = 0; i < this.m_monster_map_dead.getSize(); ++i) {
                    let obj = this.m_monster_map_dead.getKey(i);
                    if (obj == name) {
                        monsterDeadNum = this.m_monster_map_dead.getData(i);
                        break;
                    }
                }
            }
            return monsterDeadNum;
        }

        getMonsterDeadNum() {
            let monsterDeadNum = 0;
            if (this.m_monster_map_dead != null) {
                for (let i = 0; i < this.m_monster_map_dead.getSize(); ++i) {
                    let num = this.m_monster_map_dead.getData(i);
                    monsterDeadNum += num;
                }
            }
            return monsterDeadNum;
        }


        getMonsterAliveByWave(birthWave) {
            let count = 0;
            let l_MonsterAlive = this.getMonsterAlive();
            for (let i = 0; i < l_MonsterAlive.getSize(); ++i) {
                let monster = l_MonsterAlive.getData(i);
                if (monster.m_birthwave == birthWave)
                    count++;
            }
            return count;
        }

        getRoleById(id) {
            let pRole = null;
            if (this.m_AllRole_map.hasData(id)) {
                pRole = this.m_AllRole_map.getDataByKey(id);
                if (pRole.isdead()) {
                    return null;
                }
            }
            return pRole;
        }

        //获取没有死掉的怪物
        getMonsterAlive(): MapGame {
            //  this.m_monster_map_Alive.clear();
            //   for (let i = 0; i < this.m_monster_map.getSize(); ++i) {
            //       let obj = this.m_monster_map.getData(i);
            //       if (!obj.isdead()) {
            //           this.m_monster_map_Alive.put(obj.__instanceId, obj);
            //       }
            //   }
            return this.m_monster_map_Alive;//活着的怪物
        }

        //获取长度超过八百的怪物
        getExceedingMonster():Array<baseRole> {
            let ExceedingMonsterList:Array<baseRole> = new Array<baseRole>()
            this.m_monster_map.each((key, obj:baseRole)=> {
                if( obj.getSnakeLength() >= 1600 ){
                    ExceedingMonsterList.push(obj)
                }
            }, this, null);
            return ExceedingMonsterList
        }
        //暂停动画
        zanting(falg) {
            // this.m_AllRole_map.each(function (k, data) {
            //     data.zanting(falg);
            // }, this);
        }

        min_2Ptolen(obj1:baseRole , obj2:baseRole){
            let obj1_headP = obj1.getHeadPos()
            let obj1_tailP = obj1.getTailPos()
            let obj2_headP = obj2.getHeadPos()
            let obj2_tailP = obj2.getTailPos()
            let obj1len = obj1.m_curLength * (obj1.m_head.getradius())
            let obj2len = obj2.m_curLength * (obj2.m_head.getradius())
            let length1 = mathEx.getDistance(obj1_headP,obj2_headP)
            let length2 = mathEx.getDistance(obj1_headP,obj2_tailP)
            let length3 = mathEx.getDistance(obj1_tailP,obj2_headP)
            let length4 = mathEx.getDistance(obj1_headP,obj2_tailP)
            let length = Math.min(length1,length2,length3,length4)
            if(length < obj1len + obj2len){
                return true
            }
            return false
        }
        toPlayerLen( p:cc.Vec2 ):number{
            if(this.getControlPlayer()){
                return  mathEx.getDistance(p,this.getControlPlayer().getHeadPos())
            }
            return 0
        }


        //所有不参与碰撞检测的条件往这里面扔
        colide_exclude(obj:baseRole ,data2:baseRole = null):boolean{

            if( obj.getCurStateType() == g_AiType.g_AiType_dead ){
                return false
            }
            if( obj.getCurStateType() == g_AiType.g_AiType_wudi ){
                return false
            }
            if( obj.m_isAuto == true ){
                return false
            }
            // if( obj.m_isWudi ){
            //     return false
            // }
            if( data2 ){
                if( data2.__instanceId == obj.__instanceId ){
                    return false
                }
                if(!this.min_2Ptolen( data2 ,obj )){
                    return false
                }
                // if( data2.m_isWudi ){
                //     return false
                // }
                if( data2 .getCurStateType() == g_AiType.g_AiType_dead ){
                    return false
                }
                if( data2.getCurStateType() == g_AiType.g_AiType_wudi ){
                    return false
                }
                if( data2.m_isAuto == true ){
                    return false
                }
            }
            return true
        }
        colide(obj: baseRole): boolean {
            let isColide = false
            let myHeadPos = obj.getHeadPos()        //需要检测对象的头坐标
            let myradius = obj.m_head.getradius()   //对象的碰撞半径
            this.m_AllRole_map.each((key, data:baseRole )=> {
                if( !this.colide_exclude(obj ,data )  ||  isColide  || obj.m_isWudi){
                    return false
                }
                //四分搜索
                let otherradius = data.m_head.getradius()
                let searchDepth = data.m_curLength > 20 ? data.m_curLength / 10 : 1
                data.fourSearch( searchDepth ,(nodeList:Array<fourSearchNode>)=>{
                    let minDistance = 10000
                    let minNode:node = null
                    for( let k = 0; k < nodeList.length; k++){
                        //console.log(nodeList.length)
                        if( nodeList[k].m_Point != null ){
                            let tomyLen = mathEx.getDistance(nodeList[k].m_Point.getPos() ,myHeadPos)
                            if( tomyLen > 200 ){
                                nodeList[k].setComplete()
                                continue
                            }
                            if( minDistance > tomyLen){
                                minDistance = tomyLen
                                minNode = nodeList[k].m_Point
                            }
                            //即将碰撞 对方隐身不进行障碍 检测
                            if( !obj.m_isSuicide && minDistance < 120  &&  obj.m_Type == g_ObjType.monster  && !data.m_isYinshen && obj.getCurStateType() != g_AiType.g_AiType_elude  ){
                                //只检测与头的前进方向一致的坐标
                                let t_pos = cc.pAdd(myHeadPos,cc.pMult(obj.m_dir , 10))
                                let dis = mathEx.getDistance(t_pos, nodeList[k].m_Point.getPos())
                                if( dis < minDistance ){
                                    if( Math.random() * 100 < g_AI_Config.monster_elude_Prob ){
                                        obj.changeState_Ex( g_AiType.g_AiType_elude )
                                    }else{
                                        obj.changeState_Ex( g_AiType.g_AiType_stand )
                                    }
                                    //return true
                                }
                            }
                        }
                    }
                    //当前有技能正在释放
                    if(obj.m_skill_ISRelease){
                        //如果当前状态为窃取对长度的状态
                        if( obj.m_skillNode.m_Type == e_skillType.e_touqie){
                            if( minDistance  < g_skill_config.touqu_radius ){
                                obj.Skill_qiequ ( data.m_tail , data )
                            }
                        }
                    }
                    //发生碰撞
                    if( minDistance < myradius + otherradius ) {
                        data.m_killnum++
                        data.m_skill_num++
                        obj.m_killedName = data.getName()
                        //
                        ui_fight.getMe().updateShowKill(data.getName(),data.m_skinConfig["kuang_icon"],obj.getName(),obj.m_skinConfig["kuang_icon"])
                        if (data.m_Type == g_ObjType.monster) {
                            data.changeState_Ex(g_AiType.g_AiType_findFood)
                        }
                        if( data.m_skillNode.m_Type == e_skillType.e_yinshen  && data.m_skill_ISRelease ){
                            data.m_skill_ISRelease = false
                            data.m_skill_Time = data.m_skillNode.m_Time
                            data.m_skill_isEndRelease = true
                            data.m_skillNode.stop()
                        }
                        if (data.is_head( minNode ) && !data.m_isWudi ) {
                            data.m_killedName = obj.getName()
                            obj.m_killnum++
                            data.getDropPoint(mapGezi.getMe().addGeziObj.bind(mapGezi.getMe()))
                            data.changeState_Ex(g_AiType.g_AiType_dead)
                        }

                        isColide = true
                        return true
                    }
                    return false
                } , data)
                //a10.end("碰撞检测：")
            }, this, null);
            return isColide
        }
        update(t) {
            if(this.m_pause){
                return
            }
            this.m_killTime -= t
            if(this.m_killTime <= 0){
                this.m_killTime = 20
                let exceedingMonster:Array<baseRole> = this.getExceedingMonster()
                for( let k = 0; k < exceedingMonster.length; k++){
                    if( k != 0){
                        let OBJ:baseRole =  exceedingMonster[k]
                        OBJ.m_isSuicide = true
                        console.log(OBJ.getName() + "自杀模式已开启..")
                    }
                }
            }
            //地雷
            if(role_dileiMgr.getMe().getcurSize() != 0){
                role_dileiMgr.getMe().update( t )
            }
            //这里是控制碰撞间隔
            this.m_AllRole_map.each((key, data:baseRole)=> {
                //let a = proforFunc.create();
                data.loop( t );
                //a.end("逻辑循环")
                //if( this.m_CanColide == true ){
                //let b = proforFunc.create();
                    if (this.colide(data)) {
                        if(data.m_killedName){
                            //不是被墙杀死才刷逗子
                            data.getDropPoint( mapGezi.getMe().addGeziObj.bind( mapGezi.getMe()) )
                        }
                        data.m_StateControl.changeState_Ex(g_AiType.g_AiType_dead)
                    }
                //}
                //b.end("碰撞检测")
            }, this, null);
        }
    }
}