var game;
(function (game) {
    var spinePoolMgr = (function () {
        function spinePoolMgr() {
            this.m_arr_effect_dead_map_notuse = null;
            this.m_arr_effect_dead_map_use = null;
            this.m_arr_effect_birth_map_notuse = null;
            this.m_arr_effect_birth_map_use = null;
            this.m_arr_effect_dead_map_notuse = new game.MapGame();
            this.m_arr_effect_dead_map_use = new game.MapGame();
            this.m_arr_effect_birth_map_notuse = new game.MapGame();
            this.m_arr_effect_birth_map_use = new game.MapGame();
        }
        spinePoolMgr.prototype.reset = function () {
            this.m_arr_effect_dead_map_notuse.clear();
            this.m_arr_effect_dead_map_use.clear();
            this.m_arr_effect_birth_map_notuse.clear();
            this.m_arr_effect_birth_map_use.clear();
        };
        spinePoolMgr.prototype.initPlaydrophp = function () {
            for (var i = 0; i <= 5; ++i) {
                this.birth_effect(cc.p(-100000, 0));
            }
            for (var i = 0; i <= 5; ++i) {
                this.dead_effect(cc.p(-100000, 0));
            }
        };
        spinePoolMgr.prototype.birth_effect = function (pos) {
            var _DropHpLay = null;
            if (this.m_arr_effect_birth_map_notuse.getSize() > 0) {
                _DropHpLay = this.m_arr_effect_birth_map_notuse.begin();
                this.m_arr_effect_birth_map_notuse.pop();
            }
            else {
                _DropHpLay = game.spineMgr.getMe().loadSpine("chushengtexiao", game.roleMgr.getMe().getNode(), 500000);
            }
            _DropHpLay.setVisible(true);
            this.m_arr_effect_birth_map_use.put(_DropHpLay.__instanceId, _DropHpLay);
            _DropHpLay.setPosition(pos);
            var ret = _DropHpLay.setAnimation(0, "play", false);
            if (ret == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "没有动画" + name);
            }
            return _DropHpLay;
        };
        spinePoolMgr.prototype.dead_effect = function (pos) {
            var _DropHpLay = null;
            if (this.m_arr_effect_dead_map_notuse.getSize() > 0) {
                _DropHpLay = this.m_arr_effect_dead_map_notuse.begin();
                this.m_arr_effect_dead_map_notuse.pop();
            }
            else {
                _DropHpLay = game.spineMgr.getMe().loadSpine("zabingsiwang", game.roleMgr.getMe().getNode(), 500000);
            }
            _DropHpLay.setVisible(true);
            this.m_arr_effect_dead_map_use.put(_DropHpLay.__instanceId, _DropHpLay);
            _DropHpLay.setPosition(pos);
            var ret = _DropHpLay.setAnimation(0, "siwang", false);
            if (ret == null) {
                game.uiMgr.getMe().show_ui_MessageBox(true, "没有动画" + name);
            }
            // _DropHpLay.setTimeScale(0.7);
            return _DropHpLay;
        };
        spinePoolMgr.prototype.loop = function () {
            for (var i = 0; i < this.m_arr_effect_dead_map_use.getSize(); ++i) {
                var obj = this.m_arr_effect_dead_map_use.getData(i);
                if (obj) {
                    if (obj.isPlay() == false) {
                        obj.setVisible(false);
                        this.m_arr_effect_dead_map_use.remove(obj.__instanceId);
                        this.m_arr_effect_dead_map_notuse.put(obj.__instanceId, obj);
                        return;
                    }
                }
            }
            for (var i = 0; i < this.m_arr_effect_birth_map_use.getSize(); ++i) {
                var obj = this.m_arr_effect_birth_map_use.getData(i);
                if (obj) {
                    if (obj.isPlay() == false) {
                        obj.setVisible(false);
                        this.m_arr_effect_birth_map_use.remove(obj.__instanceId);
                        this.m_arr_effect_birth_map_notuse.put(obj.__instanceId, obj);
                        return;
                    }
                }
            }
        };
        spinePoolMgr.prototype.shutdownMap = function (objMap) {
            for (var i = 0; i < objMap.getSize(); ++i) {
                var obj = objMap.getData(i);
                if (obj) {
                    console.log("卸载 ui_dorpHp !" + obj._className);
                    obj.getParent().removeChild(obj.getNode(), true);
                }
            }
            objMap.clear();
        };
        spinePoolMgr.prototype.shutdown = function () {
            this.shutdownMap(this.m_arr_effect_dead_map_use);
            this.shutdownMap(this.m_arr_effect_dead_map_notuse);
            this.shutdownMap(this.m_arr_effect_birth_map_use);
            this.shutdownMap(this.m_arr_effect_birth_map_notuse);
        };
        spinePoolMgr.g_instarn = null;
        spinePoolMgr.getMe = function () {
            return spinePoolMgr.create();
        };
        spinePoolMgr.create = function () {
            if (spinePoolMgr.g_instarn == null) {
                spinePoolMgr.g_instarn = new spinePoolMgr();
                return spinePoolMgr.g_instarn;
            }
            else {
                return spinePoolMgr.g_instarn;
            }
        };
        return spinePoolMgr;
    }());
    game.spinePoolMgr = spinePoolMgr;
})(game || (game = {}));
//# sourceMappingURL=spinePoolMgr.js.map