var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Created by xieli on 2017/2/13.
 */
var game;
(function (game) {
    var chipmunk_test = (function (_super) {
        __extends(chipmunk_test, _super);
        function chipmunk_test() {
            _super.call(this);
            // 方向
            this.m_x = 5;
            this.m_y = 0;
            this.m_des = "chipmunk_test类";
        }
        chipmunk_test.prototype.oninit = function () {
            this.loadPhysicsSpace();
            this.loadDebugPhysicsSpace();
            this.loadBaseBody();
        };
        // 加载[物理空间]
        chipmunk_test.prototype.loadPhysicsSpace = function () {
            this.space = new cp.Space(); // 创建[物理空间]
            this.space.gravity = cp.v(0, 0); // 设置[物理空间重力]
            this.space.sleepTimeThreshold = 0.5; // 设置[睡眠检测临界值]
            var thickness = 10; // 物理空间围墙厚度
            var staticBody = this.space.staticBody; // 创建[静态刚体]
            var walls = [
                new cp.SegmentShape(staticBody, cp.v(-thickness, -thickness), cp.v(cc.winSize.width, -thickness), thickness),
                new cp.SegmentShape(staticBody, cp.v(-thickness, -thickness), cp.v(-thickness, cc.winSize.height), thickness),
                new cp.SegmentShape(staticBody, cp.v(cc.winSize.width + thickness, -thickness), cp.v(cc.winSize.width + thickness, cc.winSize.height), thickness),
                new cp.SegmentShape(staticBody, cp.v(-thickness, cc.winSize.height + thickness), cp.v(cc.winSize.width, cc.winSize.height + thickness), thickness) // 顶部
            ];
            // 创建围墙
            for (var i = 0; i < walls.length; i++) {
                var shape = walls[i];
                shape.setElasticity(0); // 设置[围墙的弹性系数]
                shape.setFriction(0); // 设置[围墙的摩擦力]
                shape.setCollisionType("212");
                this.space.addStaticShape(shape); // 添加[围墙到物理空间中]
            }
            this.space.addCollisionHandler("121", "122", this.collisionBegin.bind(this), this.collisionPre.bind(this), this.collisionPost.bind(this), this.collisionSeparate.bind(this));
            this.space.addCollisionHandler("121", "212", this.collisionBegin.bind(this), this.collisionPre.bind(this), this.collisionPost.bind(this), this.collisionSeparate.bind(this));
        };
        // 加载[物理空间Debug]
        chipmunk_test.prototype.loadDebugPhysicsSpace = function () {
            var node = new cc.PhysicsDebugNode(this.space);
            this.addChild(node, Number.MAX_VALUE);
        };
        chipmunk_test.prototype.update = function (dt) {
            if (this.bodyA) {
                this.bodyA.setPos(cc.p(this.bodyA.getPos().x + this.m_x, this.bodyA.getPos().y + this.m_y));
            }
            this.space.step(dt); // 物理空间[迭代]
        };
        // 加载[2个刚体]
        chipmunk_test.prototype.loadBaseBody = function () {
            var posY = cc.winSize.height / 2;
            var offsetY = 200;
            this.bodyA = this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(100, 500), "121");
            this.bodyB = this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(500, 500), "122");
            for (var i = 0; i < 10; ++i) {
                for (var k = 0; k < 10; ++k) {
                    this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(k * 50, i * 50), "122");
                }
            }
        };
        chipmunk_test.prototype.createBody = function (fileName, position, m) {
            var mess = 10; // 质量
            var pos = position;
            var file = fileName;
            var node = new cc.PhysicsSprite(file);
            this.addChild(node);
            var body = new cp.Body(mess, cp.momentForBox(mess, 10, 10));
            this.space.addBody(body);
            body.setPos(pos);
            // body.setAngle(0);
            body.sprite = node;
            var shape = new cp.BoxShape(body, 20, 20);
            // var shape = new cp.CircleShape(body, 10, 0);
            this.space.addShape(shape); // 物理空间添加形状
            node.setBody(body); // 精灵设置刚体
            shape.setCollisionType(m);
            shape.setSensor(true);
            return body;
        };
        // 碰撞
        chipmunk_test.prototype.collisionBegin = function (arbiter, space) {
            cc.log("碰到了。");
            console.log("碰到了。。碰到了。");
            return true;
        };
        // 碰撞[计算前]
        chipmunk_test.prototype.collisionPre = function (arbiter, space) {
            return true;
        };
        // 碰撞[xx]
        chipmunk_test.prototype.collisionPost = function (arbiter, space) {
        };
        // 碰撞[分开]
        chipmunk_test.prototype.collisionSeparate = function (arbiter, space) {
        };
        chipmunk_test.g_instarn = null;
        chipmunk_test.getMe = function () {
            if (chipmunk_test.g_instarn == null) {
                // console.error("chipmunk_test is null");
                return null;
            }
            return chipmunk_test.g_instarn;
        };
        chipmunk_test.ShowOrHide = function (flag) {
            game.UiBase.ShowOrHide(flag, chipmunk_test, game.uiMgr.getMe(), 100);
        };
        return chipmunk_test;
    }(game.UiBase));
    game.chipmunk_test = chipmunk_test;
})(game || (game = {}));
//# sourceMappingURL=chipmunk_test.js.map