/**
 * Created by xieli on 2017/2/13.
 */
module game {
    export class chipmunk_test extends UiBase {
        space;
        bodyA;
        bodyB;
        pivotJoint;
        mouseBody;

        listenerTouchOneByOne;

        // 方向
        m_x = 5;
        m_y = 0;

        constructor() {
            super();
            this.m_des = "chipmunk_test类";
        }

        oninit() {
            this.loadPhysicsSpace();
            this.loadDebugPhysicsSpace();
            this.loadBaseBody();
        }

        // 加载[物理空间]
        loadPhysicsSpace() {
            this.space = new cp.Space();            // 创建[物理空间]
            this.space.gravity = cp.v(0, 0);     // 设置[物理空间重力]
            this.space.sleepTimeThreshold = 0.5;    // 设置[睡眠检测临界值]

            var thickness = 10;    // 物理空间围墙厚度
            var staticBody = this.space.staticBody; // 创建[静态刚体]
            var walls = [
                new cp.SegmentShape(staticBody, cp.v(-thickness, -thickness), cp.v(cc.winSize.width, -thickness), thickness),  // 底部
                new cp.SegmentShape(staticBody, cp.v(-thickness, -thickness), cp.v(-thickness, cc.winSize.height), thickness), // 左边
                new cp.SegmentShape(staticBody, cp.v(cc.winSize.width + thickness, -thickness), cp.v(cc.winSize.width + thickness, cc.winSize.height), thickness),     // 右边
                new cp.SegmentShape(staticBody, cp.v(-thickness, cc.winSize.height + thickness), cp.v(cc.winSize.width, cc.winSize.height + thickness), thickness)      // 顶部
            ];

            // 创建围墙
            for (var i = 0; i < walls.length; i++) {
                var shape = walls[i];
                shape.setElasticity(0);   // 设置[围墙的弹性系数]
                shape.setFriction(0);       // 设置[围墙的摩擦力]
                shape.setCollisionType("212");
                this.space.addStaticShape(shape);   // 添加[围墙到物理空间中]
            }

            this.space.addCollisionHandler("121", "122",
                this.collisionBegin.bind(this),
                this.collisionPre.bind(this),
                this.collisionPost.bind(this),
                this.collisionSeparate.bind(this)
            );

            this.space.addCollisionHandler("121", "212",
                this.collisionBegin.bind(this),
                this.collisionPre.bind(this),
                this.collisionPost.bind(this),
                this.collisionSeparate.bind(this)
            );
        }

        // 加载[物理空间Debug]
        loadDebugPhysicsSpace() {
            var node = new cc.PhysicsDebugNode(this.space);
            this.addChild(node, Number.MAX_VALUE);
        }

        update(dt) {
            if(this.bodyA){
                this.bodyA.setPos(cc.p(this.bodyA.getPos().x+this.m_x,this.bodyA.getPos().y + this.m_y));
            }
            this.space.step(dt);    // 物理空间[迭代]
        }

        // 加载[2个刚体]
        loadBaseBody() {
            var posY = cc.winSize.height / 2;
            var offsetY = 200;
            this.bodyA = this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(100,500),"121");
            this.bodyB = this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(500,500),"122");

            for(let i=0;i<10;++i){
                for(let k = 0;k <10;++k){
                    this.createBody("xingjietanshishe/big/ui/image/shesheng2.png", cp.v(k*50,i*50),"122");
                }
            }
        }

        createBody(fileName, position, m?) {
            var mess = 10;      // 质量
            var pos = position ;
            var file = fileName;

            var node = new cc.PhysicsSprite(file);
            this.addChild(node);

            var body = new cp.Body(mess, cp.momentForBox(mess, 10, 10));
            this.space.addBody(body);
            body.setPos(pos);
            // body.setAngle(0);
            body.sprite = node;

            var shape = new cp.BoxShape(body, 20, 20);
            // var shape = new cp.CircleShape(body, 10, 0);
            this.space.addShape(shape); // 物理空间添加形状
            node.setBody(body);        // 精灵设置刚体
            shape.setCollisionType(m);
            shape.setSensor(true);

            return body;
        }

        // 碰撞
        collisionBegin(arbiter, space) {
            cc.log("碰到了。");
            console.log("碰到了。。碰到了。");
            return true;
        }

        // 碰撞[计算前]
        collisionPre(arbiter, space) {
            return true;
        }

        // 碰撞[xx]
        collisionPost(arbiter, space) {
        }

        // 碰撞[分开]
        collisionSeparate(arbiter, space) {
        }

        static g_instarn: chipmunk_test = null;
        static getMe = function () {
            if (chipmunk_test.g_instarn == null) {
                // console.error("chipmunk_test is null");
                return null;
            }
            return chipmunk_test.g_instarn;
        };
        static ShowOrHide = function (flag) {
            UiBase.ShowOrHide(flag, chipmunk_test, uiMgr.getMe(), 100);
        };
    }
}